% Takes the log and plots the stuff!
% variable in logsout

log = logsout;

figure(1); clf; hold on;
plot(servodata, '*')
plot(log.get('cpu_servo_out').Values)
title('Servos');


%% NEW

% Plot position in x-y grid
figure(2); clf; hold on;
plot(observed_pos.Data(:,1), observed_pos.Data(:,2), 'r');
plot(log.get('cpu_obs_pos').Values.Data(:,1), log.get('obs_pos').Values.Data(:,2), 'b');
plot(log.get('meas_pos').Values.Data(:,1), log.get('meas_pos').Values.Data(:,2), '*');
plot(log.get('meas_aref').Values.Data(:,1), log.get('meas_aref').Values.Data(:,2), 'y*');
legend('Log observed', 'Observed', 'Measured');

text(log.get('meas_pos').Values.Data(1,1), log.get('meas_pos').Values.Data(1,2), 'start')

% Plot obstacle
plot(log.get('obstacle').Values.Data(:,1), log.get('obstacle').Values.Data(:,2), 'g*');

% Plot target
plot2d(log.get('target').Values, 'c*');

axis equal;

set(gca, 'XDir', 'reverse');





figure(3); clf; hold on;
plot(observed_heading, 'r');
plot(log.get('obs_heading').Values);
plot(log.get('meas_heading').Values, '*');
legend('Log', 'observed', 'measured');
title('Heading')
grid on;


% Plot position in subsystems
% + means

figure(4); clf; hold on;

posScale = [1/640 0.7/480];

for i = 1:2
    subplot(2,1,i); hold on; grid on;
    plot(observed_pos.Time, observed_pos.Data(:,i), 'r');
    plot(log.get('obs_pos').Values.Time, log.get('obs_pos').Values.Data(:,i), 'b');
    plot(log.get('meas_pos').Values.Time, log.get('meas_pos').Values.Data(:,i), '*');
    plot(log.get('means').Values.Time, log.get('means').Values.Data(:,i)*posScale(i), 'g');
    
    thePos = log.get('meas_pos').Values.Data(:,i);
    theTime = log.get('meas_pos').Values.Time;
    invalid = thePos(log.get('pos_valid').Values.Data == 0);
    invalidTime = theTime(log.get('pos_valid').Values.Data == 0);
    
    plot(invalidTime, invalid, '*r');
    
    legend('CPU observed', 'Observed', 'Measured');
end
    
    %%
plotSweet2;
    
    