% Takes the log and plots the stuff!
% variable in logsout

log = logsout;

figure(1); clf; hold on;
plot(log.get('servo_out').Values)
title('Servos');




% Plot position in x-y grid
figure(2); clf; hold on;
plot(log.get('pos').Values.Data(:,1), log.get('pos').Values.Data(:,2), 'r');
plot(log.get('obs_pos').Values.Data(:,1), log.get('obs_pos').Values.Data(:,2), 'b');
plot(log.get('meas_pos').Values.Data(:,1), log.get('meas_pos').Values.Data(:,2), '*');
plot(log.get('meas_aref').Values.Data(:,1), log.get('meas_aref').Values.Data(:,2), 'y*');
legend('Actual', 'Observed', 'Measured');


% Plot obstacle
plot(log.get('obstacle').Values.Data(:,1), log.get('obstacle').Values.Data(:,2), 'g*');

% Plot target
plot2d(log.get('target').Values, 'c*');

set(gca, 'XDir', 'reverse');

axis equal;

figure(3); clf; hold on;
plot(log.get('heading').Values, '*');
plot(log.get('obs_heading').Values);
plot(log.get('meas_heading').Values, 'r');
legend('Actual', 'observed', 'measured');
title('Heading')
grid on;


% Plot position in subsystems

figure(4); clf; hold on;

posScale = [1 1];

for i = 1:2
    subplot(2,1,i); hold on; grid on;
    plot(log.get('pos').Values.Time, log.get('pos').Values.Data(:,i), 'r');
    plot(log.get('obs_pos').Values.Time, log.get('obs_pos').Values.Data(:,i), 'b');
    plot(log.get('meas_pos').Values.Time, log.get('meas_pos').Values.Data(:,i), '*');
    plot(log.get('means').Values.Time, log.get('means').Values.Data(:,i)*posScale(i), 'g');
    plot(log.get('means').Values.Time, (log.get('means').Values.Data(:,i) + 10*9)*posScale(i), 'g--');
    
    
    
    thePos = log.get('meas_pos').Values.Data(:,i);
    theTime = log.get('meas_pos').Values.Time;
    invalid = thePos(log.get('wildpoint').Values.Data == 1);
    invalidTime = theTime(log.get('wildpoint').Values.Data == 1);
    
    plot(invalidTime, invalid, '*r');
    
    
    legend('Actual', 'Observed', 'Measured');
end
    
% Plot position in subsystems

figure(5); clf; hold on;

posScale = [1 1];

for i = 1:2
    subplot(2,1,i); hold on; grid on;
 
    plot(log.get('aref_pos').Values.Time, log.get('aref_pos').Values.Data(:,i), 'y');
    plot(log.get('meas_aref').Values.Time, log.get('meas_aref').Values.Data(:,i), '*');
    plot(log.get('means').Values.Time, log.get('means').Values.Data(:,2+i)*posScale(i), 'g');
    plot(log.get('means').Values.Time, (log.get('means').Values.Data(:,2+i) + 0.01*9)*posScale(i), 'g--');
    
    
    
    thePos = log.get('meas_pos').Values.Data(:,i);
    theTime = log.get('meas_pos').Values.Time;
    invalid = thePos(log.get('wildpoint').Values.Data == 1);
    invalidTime = theTime(log.get('wildpoint').Values.Data == 1);
    
    plot(invalidTime, invalid, '*r');
    
    
    legend('Actual', 'Measured');
end
    
    
    
    
    
    
    
    
    
    