%% Sets up some parameters

Kp = Simulink.Parameter;
Kp.Value = 5;
Kp.CoderInfo.StorageClass = 'ExportedGlobal';
Kp.DataType = 'double';

Kp_pos = Simulink.Parameter;
Kp_pos.Value = 10;
Kp_pos.CoderInfo.StorageClass = 'ExportedGlobal';
Kp_pos.DataType = 'double';

Kp_formation = Simulink.Parameter;
Kp_formation.Value = 0.7;
Kp_formation.CoderInfo.StorageClass = 'ExportedGlobal';
Kp_formation.DataType = 'double';

Setpoint = Simulink.Parameter;
Setpoint.Value = 0;
Setpoint.CoderInfo.StorageClass = 'ExportedGlobal';
Setpoint.DataType = 'int16';

V_xy = Simulink.Parameter;
V_xy.Value = [0 0];
V_xy.DataType = 'int16';
V_xy.CoderInfo.StorageClass = 'ExportedGlobal';

NActiveAgents = Simulink.Parameter;
NActiveAgents.Value = 1;
NActiveAgents.StorageClass = 'ExportedGlobal';

controllerMethod = Simulink.Parameter;
controllerMethod.Value = 2;
controllerMethod.StorageClass = 'ExportedGlobal';

activateLeaderV = Simulink.Parameter;
activateLeaderV.DataType = 'int32';
activateLeaderV.Value = 0;
activateLeaderV.StorageClass = 'ExportedGlobal';

maxRobots = Simulink.Parameter;
maxRobots.Value = 4;
maxRobots.StorageClass = 'ExportedGlobal';


% Config struct
runConfig = Simulink.Parameter;
runConfig.DataType = 'Bus: RunConfig';
runConfig.Value = Simulink.Bus.createMATLABStruct('RunConfig');
runConfig.StorageClass = 'ExportedGlobal';





%% CTRL stuff

CTRLconfig.obstacle_d = 0.2;
CTRLconfig.collision_d = 0.38;
CTRLconfig.debug = 0;
CTRLconfig.N = maxRobots.Value;
CTRLconfig.p = 2;