%% Assumes data in data

%% Returns a lot, together with the variable log

heading = data.mlog1*pi/180;
x = data.X;
y = data.Y;
time = data.time;

simdata = timeseries;
simdata.Name = 'meas_pos';
simdata.Time = time;
simdata.Data = [x y];

meas_pos = simdata;

arefdata = timeseries;
arefdata.Name = 'meas_aref';
arefdata.Time = time;
arefdata.Data = [data.aref_X data.aref_Y];

validCheckdata = timeseries;
validCheckdata.Name = 'validCheckdata';
validCheckdata.Time = time;
validCheckdata.Data = [data.pos_valid data.angle_valid];

pos_valid = timeseries;
pos_valid.Name = 'pos_valid';
pos_valid.Time = time;
pos_valid.Data = [data.pos_valid];

aref_valid = timeseries;
aref_valid.Name = 'aref_valid';
aref_valid.Time = time;
aref_valid.Data = [data.angle_valid];


servodata = timeseries;
servodata.Name = 'servo_out';
servodata.Time = time;
servodata.Data = [data.servo1 data.servo2 data.servo3];

observed_pos = timeseries;
observed_pos.Name = 'obs_pos';
observed_pos.Time = time;
observed_pos.Data = [data.observed_pos1 data.observed_pos2];

observed_heading = timeseries;
observed_heading.Name = 'obs_heading';
observed_heading.Time = time;
observed_heading.Data = data.mlog1;

obstacle = timeseries;
obstacle.Name = 'obstacle';
obstacle.Time = time;
obstacle.Data = [data.obstacle_1_X data.obstacle_1_Y];

obstacles = repmat(timeseries, [1 3]);

for i = 1:3
   obstacles(i).Name = ['obstacle_' num2str(i)];
   obstacles(i).Time = time;
   obstacles(i).Data = eval(sprintf('[data.obstacle_%d_X data.obstacle_%d_Y]', i, i));
end



% NSB logging stuff
nsb_v_target = timeseries;
nsb_v_target.Name = 'nsb_v_target';
nsb_v_target.Time = time;
nsb_v_target.Data = [data.mlog2 data.mlog3];

nsb_v_obstacle = timeseries;
nsb_v_obstacle.Name = 'nsb_v_obstacle';
nsb_v_obstacle.Time = time;
nsb_v_obstacle.Data = [data.mlog4 data.mlog5];

nsb_active_obstacle = timeseries;
nsb_active_obstacle.Name = 'nsb_active_obstacle';
nsb_active_obstacle.Time = time;
nsb_active_obstacle.Data = [data.mlog8];

nsb_v = timeseries;
nsb_v.Name = 'nsb_v';
nsb_v.Time = time;
nsb_v.Data = [data.mlog6 data.mlog7];

target = timeseries;
target.Name = 'target';
target.Time = time;
target.Data = [data.target_X data.target_Y];



% Add to datastruct array
log = Simulink.SimulationData.Dataset;

log = log.addElement(simdata);
log = log.addElement(arefdata);
log = log.addElement(aref_valid);
log = log.addElement(pos_valid);
log = log.addElement(observed_pos);
log = log.addElement(observed_heading);
log = log.addElement(obstacle);
log = log.addElement(obstacles);
log = log.addElement(target);
log = log.addElement(nsb_v_target);
log = log.addElement(nsb_v_obstacle);
log = log.addElement(nsb_active_obstacle);
log = log.addElement(nsb_v);

%% Convert to same format as a simulink simulation
realLog = Simulink.SimulationData.Dataset;
for i = 1:log.numElements
    entry = log.getElement(i);
    

    signal = repmat(Simulink.SimulationData.Signal, size(entry));
    
    if(size(entry, 2) > 1)
        for j = 1:size(entry, 2)
            signal(j).Values = entry(j);
            signal(j).Name = entry(j).Name;
            signal(j).Name
            realLog = realLog.addElement(signal(j));
        end

    else
        signal.Values = entry;
        signal.Name = entry.Name;
        realLog = realLog.addElement(signal);
    end
    
end

log = realLog;


