logRootPath = '../';

nRobots = 4;

filename = 'log-2013-05-03_13-00-45.txt';
filename = 'log-2013-05-03_14-41-01.txt';




%% Get data
[data, filename] = getBBLog(filename, [logRootPath '1/']);  % gets the newest from Njord
dataCell = {};
dataCell{1} = data;
dirs = {};
for i = 1:1
   dirs{i} = [logRootPath num2str(i+1) '\']; 
end



logCell = {};
parseLog;
logCell{1} = log;

for i = 1:length(dirs) 
    try
        data = getBBLog(filename, dirs{i});
    catch ex
        disp(ex.message);
        continue
    end
    
    % if ok, store
    dataCell{end+1} = data;
    parseLog;
    logCell{end+1} = log;
    
end



%% Plot
figure(1); clf; hold on;
endTime = 13;
time= logCell{1}.get('obs_pos').Values.Time;
timeRange = time<=endTime;

colors = {'b', 'r', 'g', 'm'};
finalHandles = [];
legendStrings = {};

for i = 1:2
    handles = plot2d(logCell{i}.get('obs_pos').Values, ['--' colors{i}], 1, timeRange);
    finalHandles(i) = handles(2);
    legendStrings{i} = num2str(i);
    
end
legend(finalHandles, legendStrings);
axis equal;
xlim([ 0.3 1.3]);
ylim([ 0.4 0.85]);

exportPlot(1, 'robot_collision_2_agents')


%% Plot x and y in seperate plots

figure(4); clf; hold on;

log = logCell{1};

for i = 1:2
    subplot(2,1,i); hold on; grid on;
   
    plot(log.get('obs_pos').Values.Time, log.get('obs_pos').Values.Data(:,i), 'b');
    plot(log.get('meas_pos').Values.Time, log.get('meas_pos').Values.Data(:,i), '*');
   
    
    thePos = log.get('meas_pos').Values.Data(:,i);
    theTime = log.get('meas_pos').Values.Time;
    invalid = thePos(log.get('pos_valid').Values.Data == 0);
    invalidTime = theTime(log.get('pos_valid').Values.Data == 0);
    
    plot(invalidTime, invalid, '*r');
    
    legend( 'Observed', 'Measured');
end



%% Plot
CTRLconfig.N = 2;
CTRLconfig.obstacle_d = 0.2-0.02;
CTRLconfig.collision_d = 0.38;


exportStruct.doExport = 1;
exportStruct.name     = 'robot_collision_2_agents';
exportStruct.timeSlots= [0 1.6 3.5 4.7 6.9 11.7];
exportStruct.doExtra  = [0 0 1 1 0 0];
exportStruct.minBox = [0.8 0.8];
exportStruct.plotAxis = 0;
exportStruct.plotTarget = 0;
exportStruct.setVLength = 0.38;



plotSimulation(CTRLconfig, logCell, figure(2), exportStruct);

