logRootPath = '../';

nRobots = 4;

filename = 'log-2013-05-09_10-35-43.txt';


%% Get data
[data, filename] = getBBLog(filename, [logRootPath '1/']);  % gets the newest from Njord
dataCell = {};
dataCell{1} = data;
dirs = {'W:\', 'V:\', 'U:\'};
for i = 1:3
   dirs{i} = [logRootPath num2str(i+1) '\']; 
end



logCell = {};
parseLog;
logCell{1} = log;

for i = 1:length(dirs) 
    try
        data = getBBLog(filename, dirs{i});
    catch ex
        disp(ex.message);
        continue
    end
    
    % if ok, store
    dataCell{end+1} = data;
    parseLog;
    logCell{end+1} = log;
    
end

%% Do some hackish robot number replacement
newLogCell = logCell;
newLogCell{1} = logCell{2};
newLogCell{2} = logCell{3};
newLogCell{3} = logCell{4};
newLogCell{4} = logCell{1};

logCell = newLogCell;


%% Plot
figure(1); clf; hold on;
endTime = 50;
time= logCell{1}.get('obs_pos').Values.Time;
timeRange = time<=endTime;

colors = {'b', 'r', 'g', 'm'};
finalHandles = [];
legendStrings = {};

for i = 1:4 
    handles = plot2d(logCell{i}.get('obs_pos').Values, ['--' colors{i}], 1);
    finalHandles(i) = handles(2);
    legendStrings{i} = num2str(i);
    
end
legend(finalHandles, legendStrings);
axis equal;

%exportPlot(1, 'robot_passivity_formation_full_plot')

%% Plot
CTRLconfig.N = 4;
CTRLconfig.obstacle_d = 0.2-0.02;
CTRLconfig.collision_d = 0.38;


exportStruct.doExport = 0;
exportStruct.name     = 'robot_collision_4_agents';
exportStruct.timeSlots= [0 1.6 3.5 4.7 6.9 11.7];
exportStruct.doExtra  = [0 0 1 1 0 0];
exportStruct.minBox = [0.8 0.8];
exportStruct.plotAxis = 0;
exportStruct.plotTarget = 0;
exportStruct.setVLength = 0.38;



plotSimulation(CTRLconfig, logCell, figure(2), exportStruct);
