/*
 * File: Controller.cpp
 *
 * Code generated for Simulink model 'Controller'.
 *
 * Model version                  : 1.432
 * Simulink Coder version         : 8.3 (R2012b) 20-Jul-2012
 * TLC version                    : 8.3 (Jul 21 2012)
 * C/C++ source code generated on : Wed Jun 05 11:40:13 2013
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "Controller.h"
#include "Controller_private.h"

const MagnetometerInput Controller_rtZMagnetometerInput = {
  0,                                   /* x */
  0,                                   /* y */
  0                                    /* z */
} ;                                    /* MagnetometerInput ground */

const CameraInputPoint Controller_rtZCameraInputPoint = {
  {
    0.0F, 0.0F }
  ,                                    /* point */
  FALSE                                /* valid */
} ;                                    /* CameraInputPoint ground */

const CamInput Controller_rtZCamInput = {
  {
    {
      0.0F, 0.0F }
    ,                                  /* point */
    FALSE                              /* valid */
  },                                   /* pos */

  {
    {
      0.0F, 0.0F }
    ,                                  /* point */
    FALSE                              /* valid */
  }                                    /* aref */
} ;                                    /* CamInput ground */

/* Exported block parameters */
RunConfig runConfig = {
  0.0,
  0,
  0,
  Single,
  0.0,
  FormationControl
} ;                                    /* Variable: runConfig
                                        * Referenced by:
                                        *   '<S10>/Active Formation'
                                        *   '<S10>/Constant1'
                                        *   '<S10>/Formation Rotation'
                                        *   '<S10>/N Active Agents'
                                        *   '<S19>/If force obstacle deactivate'
                                        */

real_T Kp = 5.0;                       /* Variable: Kp
                                        * Referenced by: '<S9>/Kp'
                                        */
real_T Kp_formation = 0.7;             /* Variable: Kp_formation
                                        * Referenced by: '<S31>/Gain'
                                        */
real_T controllerMethod = 2.0;         /* Variable: controllerMethod
                                        * Referenced by: '<S2>/Constant'
                                        */
int16_T Setpoint = 0;                  /* Variable: Setpoint
                                        * Referenced by: '<Root>/Heading setpoint'
                                        */

/* Exported block states */
real_T logEntry[10];                   /* '<Root>/Log memory' */

/* Block signals (auto storage) */
BlockIO_Controller Controller_B;

/* Block states (auto storage) */
D_Work_Controller Controller_DWork;

/* External inputs (root inport signals with auto storage) */
ExternalInputs_Controller Controller_U;

/* External outputs (root outports fed by signals with auto storage) */
ExternalOutputs_Controller Controller_Y;

/* Real-time model */
RT_MODEL_Controller Controller_M_;
RT_MODEL_Controller *const Controller_M = &Controller_M_;

/* Exported data definition */
real_T r;

/*
 * Output and update for atomic system:
 *    '<S25>/Generate z'
 *    '<S26>/Generate z'
 */
void Controller_Generatez(const real_T rtu_D[24], const real_T rtu_pos[8],
  rtB_Generatez_Controller *localB)
{
  int32_T link;
  int32_T agent;

  /* MATLAB Function 'Utility Functions/Generate Z/Generate z': '<S27>:1' */
  /* coder.varsize('pos', [2 4], [0 1]) */
  /*  Generate from D! */
  /*  D has links as columns, the different agents as rows. */
  /*  Assume p is the first dimension. */
  /* p = size(pos, 1); */
  /*  Set up zd size */
  /* '<S27>:1:15' */
  memset(&localB->z[0], 0, 12U * sizeof(real_T));

  /* '<S27>:1:17' */
  for (link = 0; link < 6; link++) {
    /* '<S27>:1:17' */
    /* '<S27>:1:18' */
    for (agent = 0; agent < 4; agent++) {
      /* '<S27>:1:18' */
      /* '<S27>:1:19' */
      localB->z[link << 1] += rtu_D[(link << 2) + agent] * rtu_pos[agent << 1];
      localB->z[1 + (link << 1)] = rtu_D[(link << 2) + agent] * rtu_pos[(agent <<
        1) + 1] + localB->z[(link << 1) + 1];

      /* '<S27>:1:18' */
    }

    /* '<S27>:1:17' */
  }

  /* % ANOTHER MORE COMPLICATED SOLUTION */
  /*  z = zeros(p, numberOfLinks); */
  /*   */
  /*  for k = 1:numberOfLinks */
  /*     dk = kron(ones(p,1), D(:,k)'); */
  /*     z(:,k) = dot(pos, dk, 2); */
  /*  end */
  /*   */
}

/*
 * Output and update for atomic system:
 *    '<S34>/Task activator'
 *    '<S38>/Task activator'
 */
void Controller_Taskactivator(const real_T rtu_v_obstacle[2], real_T
  rtu_dist_obstacle, const real_T rtu_v_lower_task[2],
  rtB_Taskactivator_Controller *localB, real_T rtp_d)
{
  real_T dotProduct;
  boolean_T y;
  int32_T k;
  boolean_T exitg;
  real_T v_obstacle_idx;
  real_T v_obstacle_idx_0;

  /* MATLAB Function 'Control/Behavioral/Task Activator/Task activator': '<S35>:1' */
  /* d = 0.5;  */
  /*  First, check if v_obstacle == 0 */
  /*  If so, that task is already deactivated by internal mechanisms */
  y = TRUE;
  k = 0;
  exitg = FALSE;
  while ((!exitg) && (k < 2)) {
    if ((rtu_v_obstacle[k] == 0.0) == 0) {
      y = FALSE;
      exitg = TRUE;
    } else {
      k++;
    }
  }

  if (y) {
    /* '<S35>:1:9' */
    k = 0;
  } else {
    /*  If v_obstacle rediculisly small */
    if (fkfcopppfcbigdba_norm(rtu_v_obstacle) < 0.01) {
      /* '<S35>:1:14' */
      /* '<S35>:1:15' */
      k = 0;
    } else {
      /*  Then, check if there are any v_lower */
      y = TRUE;
      k = 0;
      exitg = FALSE;
      while ((!exitg) && (k < 2)) {
        if ((rtu_v_lower_task[k] == 0.0) == 0) {
          y = FALSE;
          exitg = TRUE;
        } else {
          k++;
        }
      }

      if (y) {
        /*  No lower task, should always activate */
        /* '<S35>:1:22' */
        k = 1;
      } else {
        /* '<S35>:1:25' */
        dotProduct = fkfcopppfcbigdba_norm(rtu_v_obstacle);
        v_obstacle_idx = rtu_v_obstacle[0] / dotProduct;
        v_obstacle_idx_0 = rtu_v_obstacle[1] / dotProduct;

        /* '<S35>:1:26' */
        dotProduct = fkfcopppfcbigdba_norm(rtu_v_lower_task);

        /*  An important point is that if we are inside the circle, the speed of */
        /*  obstacle avoidance is pointing outwards. We are only intereseted in the */
        /*  direction directly to the obstacle. Thus, if we are inside, reverse the */
        /*  vector */
        if (rtu_dist_obstacle < rtp_d) {
          /* '<S35>:1:32' */
          /* '<S35>:1:33' */
          v_obstacle_idx = -v_obstacle_idx;
          v_obstacle_idx_0 = -v_obstacle_idx_0;
        }

        /*  First, check for valid triangle */
        /*  That is, the dot-product should not be above 1 */
        /* '<S35>:1:42' */
        dotProduct = rtu_v_lower_task[0] / dotProduct * v_obstacle_idx +
          rtu_v_lower_task[1] / dotProduct * v_obstacle_idx_0;
        if (fabs(dotProduct) > 1.0) {
          /* '<S35>:1:44' */
          /* '<S35>:1:45' */
          if (dotProduct < 0.0) {
            dotProduct = -1.0;
          } else if (dotProduct > 0.0) {
            dotProduct = 1.0;
          } else {
            if (dotProduct == 0.0) {
              dotProduct = 0.0;
            }
          }
        }

        /* '<S35>:1:48' */
        dotProduct = fabs(acos(dotProduct));

        /*  And, a valid triangle has an angle of less than pi */
        if (dotProduct + 0.01 >= 3.1415926535897931) {
          /* '<S35>:1:53' */
          /*  always deactivate */
          /* '<S35>:1:55' */
          k = 0;
        } else {
          /*  Also calculate the d_hat */
          /* '<S35>:1:61' */
          /* '<S35>:1:63' */
          k = 0;

          /* active = 1; */
          /* if angle_diff < pi/2 */
          /*     active=1; */
          /*   */
          if (rtu_dist_obstacle * sin(dotProduct) < rtp_d) {
            /* '<S35>:1:75' */
            /* '<S35>:1:76' */
            k = 1;
          }

          if (dotProduct > 1.5707963267948966) {
            /* '<S35>:1:79' */
            /* '<S35>:1:80' */
            k = 0;
          }
        }
      }
    }
  }

  localB->active = (real_T)k;
}

/*
 * Initial conditions for atomic system:
 *    '<S63>/Running Average'
 *    '<S66>/Running Average'
 */
void Controller_RunningAverage_Init(rtDW_RunningAverage_Controller *localDW)
{
  localDW->k = 0.0;
}

/*
 * Start for atomic system:
 *    '<S63>/Running Average'
 *    '<S66>/Running Average'
 */
void Controller_RunningAverage_Start(rtB_RunningAverage_Controller *localB,
  rtDW_RunningAverage_Controller *localDW)
{
  localB->means[0] = 0.0;
  localB->means[1] = 0.0;
  localDW->k = 0.0;
}

/*
 * Output and update for atomic system:
 *    '<S63>/Running Average'
 *    '<S66>/Running Average'
 */
void Controller_RunningAverage(const CameraInputPoint *rtu_in0, const
  CameraInputPoint *rtu_in1, const CameraInputPoint *rtu_in2, const
  CameraInputPoint *rtu_in3, const CameraInputPoint *rtu_in4,
  rtB_RunningAverage_Controller *localB, rtDW_RunningAverage_Controller *localDW)
{
  CameraInputPoint in[5];
  real_T varMat[10];
  int32_T ix;
  int32_T iy;
  int32_T ixstart;
  real_T s;
  int32_T j;

  /* MATLAB Function 'running average/Running Average': '<S64>:1' */
  /* '<S64>:1:12' */
  in[0] = *rtu_in0;
  in[1] = *rtu_in1;
  in[2] = *rtu_in2;
  in[3] = *rtu_in3;
  in[4] = *rtu_in4;

  /*  Calculate current variance on everything */
  /* '<S64>:1:15' */
  memset(&varMat[0], 0, 10U * sizeof(real_T));

  /* '<S64>:1:17' */
  for (iy = 0; iy < 5; iy++) {
    /* '<S64>:1:17' */
    /* '<S64>:1:18' */
    varMat[iy << 1] = in[iy].point[0];
    varMat[1 + (iy << 1)] = in[iy].point[1];

    /* '<S64>:1:17' */
  }

  /* '<S64>:1:22' */
  iy = -1;
  ixstart = -1;
  for (j = 0; j < 2; j++) {
    ixstart++;
    ix = ixstart + 2;
    s = varMat[ixstart] + varMat[ix];
    ix += 2;
    s += varMat[ix];
    ix += 2;
    s += varMat[ix];
    ix += 2;
    s += varMat[ix];
    iy++;
    localB->means[iy] = s;
  }

  localB->means[0] /= 5.0;
  localB->means[1] /= 5.0;
  if (localDW->k < 5.0) {
    /* '<S64>:1:24' */
    /* '<S64>:1:25' */
    localB->means[0] = rtu_in0->point[0];
    localB->means[1] = rtu_in0->point[1];
  }

  /* '<S64>:1:28' */
  localDW->k++;
}

/* Model step function */
void Controller_step(void)
{
  /* local block i/o variables */
  CamInput rtb_BusConversion_InsertedFor_O;
  CameraInputPoint rtb_Delay_l;
  CameraInputPoint rtb_Delay1_n;
  CameraInputPoint rtb_Delay2_o;
  CameraInputPoint rtb_Delay3_k;
  CameraInputPoint rtb_ImpSel_InsertedFor_In1_a_ob;
  CameraInputPoint rtb_Delay1_j;
  CameraInputPoint rtb_Delay_f;
  CameraInputPoint rtb_Delay2_e;
  CameraInputPoint rtb_Delay3_l;
  real_T rtb_Observer_o2;
  real_T rtb_Sum1[2];
  real_T rtb_Switch[2];
  real_T rtb_D[24];
  real_T rtb_rotated_formation[8];
  real_T rtb_v_o[2];
  real_T rtb_obs_distance;
  real_T rtb_v_i[2];
  real_T rtb_obs_distance_d;
  real_T rtb_concated_pos[8];
  int32_T rtb_UnitDelay[3];

  /* local scratch DWork variables */
  int32_T ForEach_itr;
  int32_T ForEach_itr_c;
  CameraInputPoint in[5];
  real_T varMat[10];
  int32_T iy;
  int32_T ixstart;
  static const int8_T b[24] = { -1, 1, 0, 0, -1, 0, 1, 0, -1, 0, 0, 1, 0, -1, 1,
    0, 0, -1, 0, 1, 0, 0, -1, 1 };

  static const int8_T c[24] = { -1, 1, 0, 0, 1, 0, -1, 0, 0, -1, 1, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0 };

  static const int8_T d[24] = { -1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0 };

  real_T z_tilde[12];
  real_T b_K[96];
  static const int8_T B[4] = { 1, 0, 0, 1 };

  real_T sigma;
  real_T J[2];
  real_T J_0[2];
  real_T rtb_Gain_e;
  boolean_T rtb_LogicalOperator;
  int32_T rtb_formation_reached;
  real_T rtb_Merge[2];
  real_T rtb_means[2];
  real_T rtb_complete;
  real_T rtb_MatrixMultiply[3];
  real_T rtb_MultiportSwitch[8];
  real_T rtb_ImpAsg_InsertedFor_Out1_at_[8];
  real_T rtb_ImpAsg_InsertedFor_Out1_a_k[6];
  real_T tmp[2];
  real_T tmp_0[2];
  real_T tmp_1[2];
  boolean_T tmp_2[6];
  boolean_T tmp_3[6];
  real_T tmp_4[2];
  real_T tmp_5[2];
  real_T tmp_6[2];
  real_T b_K_0[96];
  real_T z_tilde_0[12];
  real_T b_data[24];
  int32_T tmp_data[6];
  int32_T tmp_sizes[2];
  int32_T tmp_data_0[6];
  int32_T tmp_sizes_0[2];
  int32_T b_sizes_idx;
  real32_T rtb_ImpSel_InsertedFor_In1_at_0;
  real32_T rtb_ImpSel_InsertedFor_In1_at_1;
  real_T rtb_N_k_idx;
  real_T rtb_N_k_idx_0;
  real_T rtb_N_k_idx_1;
  int32_T rtb_Switch_h_idx_0;
  int32_T rtb_Switch_h_idx_2;
  int16_T tmp_7;

  /* BusCreator: '<Root>/BusConversion_InsertedFor_Observer_at_inport_0' incorporates:
   *  BusCreator: '<Root>/BusConversion_InsertedFor_Observer_at_inport_0'
   *  Inport: '<Root>/camera'
   */
  rtb_BusConversion_InsertedFor_O = Controller_U.camera;

  /* UnitDelay: '<Root>/Unit Delay' */
  rtb_UnitDelay[0] = Controller_DWork.UnitDelay_DSTATE[0];
  rtb_UnitDelay[1] = Controller_DWork.UnitDelay_DSTATE[1];
  rtb_UnitDelay[2] = Controller_DWork.UnitDelay_DSTATE[2];

  /* ModelReference: '<Root>/Observer' */
  Observer(&rtb_BusConversion_InsertedFor_O, rtb_UnitDelay,
           &Controller_Y.current_pos[0], &rtb_Observer_o2,
           &Controller_Y.observer_valid);

  /* Gain: '<S3>/Gain' */
  rtb_Gain_e = 57.295779513082323 * rtb_Observer_o2;

  /* MATLAB Function: '<S57>/Running Average' incorporates:
   *  Delay: '<S57>/Delay'
   *  Delay: '<S57>/Delay1'
   *  Delay: '<S57>/Delay2'
   *  Delay: '<S57>/Delay3'
   *  Inport: '<Root>/target'
   */
  /* MATLAB Function 'Controller/Formation speed controller/Leader Controller/Static point/Running Average': '<S62>:1' */
  /* '<S62>:1:13' */
  in[0] = Controller_U.target;
  in[1] = Controller_DWork.Delay1_DSTATE;
  in[2] = Controller_DWork.Delay_DSTATE[0U];
  in[3] = Controller_DWork.Delay2_DSTATE[0U];
  in[4] = Controller_DWork.Delay3_DSTATE[0U];

  /*  Calculate current variance on everything */
  /* '<S62>:1:16' */
  memset(&varMat[0], 0, 10U * sizeof(real_T));

  /* '<S62>:1:18' */
  for (iy = 0; iy < 5; iy++) {
    /* '<S62>:1:18' */
    /* '<S62>:1:19' */
    varMat[iy << 1] = in[iy].point[0];
    varMat[1 + (iy << 1)] = in[iy].point[1];

    /* '<S62>:1:18' */
  }

  /* '<S62>:1:23' */
  iy = -1;
  ixstart = -1;
  for (rtb_Switch_h_idx_2 = 0; rtb_Switch_h_idx_2 < 2; rtb_Switch_h_idx_2++) {
    ixstart++;
    rtb_Switch_h_idx_0 = ixstart + 2;
    rtb_complete = varMat[ixstart] + varMat[rtb_Switch_h_idx_0];
    rtb_Switch_h_idx_0 += 2;
    rtb_complete += varMat[rtb_Switch_h_idx_0];
    rtb_Switch_h_idx_0 += 2;
    rtb_complete += varMat[rtb_Switch_h_idx_0];
    rtb_Switch_h_idx_0 += 2;
    rtb_complete += varMat[rtb_Switch_h_idx_0];
    iy++;
    rtb_means[iy] = rtb_complete;
  }

  rtb_means[0] /= 5.0;
  rtb_means[1] /= 5.0;

  /* '<S62>:1:24' */
  rtb_complete = 1.0;
  if (Controller_DWork.k < 5.0) {
    /* '<S62>:1:25' */
    /* '<S62>:1:26' */
    rtb_means[0] = Controller_U.target.point[0];
    rtb_means[1] = Controller_U.target.point[1];

    /* '<S62>:1:27' */
    rtb_complete = 0.0;
  }

  /* '<S62>:1:30' */
  Controller_DWork.k++;

  /* End of MATLAB Function: '<S57>/Running Average' */

  /* MATLAB Function: '<S57>/MATLAB Function' */
  /* MATLAB Function 'Controller/Formation speed controller/Leader Controller/Static point/MATLAB Function': '<S61>:1' */
  if (!Controller_DWork.lastBeforeComplete_not_empty) {
    /* '<S61>:1:6' */
    /* '<S61>:1:7' */
    Controller_DWork.lastBeforeComplete[0] = rtb_means[0];
    Controller_DWork.lastBeforeComplete[1] = rtb_means[1];
    Controller_DWork.lastBeforeComplete_not_empty = TRUE;
  }

  if (rtb_complete != 0.0) {
    /* '<S61>:1:11' */
    rtb_means[0] = Controller_DWork.lastBeforeComplete[0];
    rtb_means[1] = Controller_DWork.lastBeforeComplete[1];
  } else {
    /* '<S61>:1:13' */
    Controller_DWork.lastBeforeComplete[0] = rtb_means[0];
    Controller_DWork.lastBeforeComplete[1] = rtb_means[1];

    /* '<S61>:1:14' */
  }

  /* End of MATLAB Function: '<S57>/MATLAB Function' */

  /* If: '<S22>/If' incorporates:
   *  Constant: '<S10>/Constant1'
   *  Constant: '<S58>/Constant2'
   *  DataTypeConversion: '<Root>/Data Type Conversion2'
   *  DataTypeConversion: '<S22>/Data Type Conversion'
   *  Inport: '<Root>/agent_index'
   *  Inport: '<Root>/mission_v'
   *  Inport: '<S55>/common_v'
   *  MATLAB Function: '<S59>/Reach Target'
   */
  if ((Controller_U.agent_index == 1) && (runConfig.activateLeaderV == 1)) {
    /* Outputs for IfAction SubSystem: '<S22>/Goto Target' incorporates:
     *  ActionPort: '<S56>/Action Port'
     */
    /* MATLAB Function: '<S59>/Reach Target' */
    /* MATLAB Function 'Control/Behavioral/Reach Target/Reach Target': '<S60>:1' */
    /*  Behavior of the "reach target" task */
    /*  Target location */
    /*  Setup matrix */
    /* '<S60>:1:10' */
    /*  calculate jacobian */
    /* '<S60>:1:15' */
    rtb_complete = rtb_means[0] - Controller_Y.current_pos[0];
    rtb_N_k_idx_0 = rtb_means[1] - Controller_Y.current_pos[1];
    rtb_Merge[0] = 0.5 * rtb_complete + 0.0 * rtb_N_k_idx_0;
    rtb_Merge[1] = 0.0 * rtb_complete;
    rtb_Merge[1] += 0.5 * rtb_N_k_idx_0;

    /* End of Outputs for SubSystem: '<S22>/Goto Target' */
  } else if ((Controller_U.agent_index != 1) && (runConfig.activateLeaderV == 1))
  {
    /* Outputs for IfAction SubSystem: '<S22>/From robot 1' incorporates:
     *  ActionPort: '<S55>/Action Port'
     */
    rtb_Merge[0] = Controller_U.mission_v[0];
    rtb_Merge[1] = Controller_U.mission_v[1];

    /* End of Outputs for SubSystem: '<S22>/From robot 1' */
  } else {
    /* Outputs for IfAction SubSystem: '<S22>/From robot 1' incorporates:
     *  ActionPort: '<S55>/Action Port'
     */
    /* Outputs for IfAction SubSystem: '<S22>/zero out' incorporates:
     *  ActionPort: '<S58>/Action Port'
     */
    rtb_Merge[0] = 0.0;
    rtb_Merge[1] = 0.0;

    /* End of Outputs for SubSystem: '<S22>/zero out' */
    /* End of Outputs for SubSystem: '<S22>/From robot 1' */
  }

  /* End of If: '<S22>/If' */

  /* MATLAB Function: '<S19>/saturate1' incorporates:
   *  Constant: '<S19>/Constant2'
   */
  /* MATLAB Function 'System Models/model_sat/saturate': '<S32>:1' */
  /* '<S32>:1:4' */
  rtb_means[0] = rtb_Merge[0];
  rtb_means[1] = rtb_Merge[1];
  if (fkfcopppfcbigdba_norm(rtb_Merge) > 0.06) {
    /* '<S32>:1:6' */
    /* '<S32>:1:7' */
    rtb_complete = fkfcopppfcbigdba_norm(rtb_Merge);
    rtb_means[0] = rtb_Merge[0] / rtb_complete * 0.06;
    rtb_means[1] = rtb_Merge[1] / rtb_complete * 0.06;
  }

  /* End of MATLAB Function: '<S19>/saturate1' */

  /* MATLAB Function: '<S10>/Incidence Matrix' incorporates:
   *  Constant: '<S10>/N Active Agents'
   */
  /* MATLAB Function 'Controller/Formation speed controller/Incidence Matrix': '<S21>:1' */
  if (runConfig.nRobots == 4.0) {
    /* '<S21>:1:4' */
    /* '<S21>:1:5' */
    for (rtb_Switch_h_idx_2 = 0; rtb_Switch_h_idx_2 < 24; rtb_Switch_h_idx_2++)
    {
      rtb_D[rtb_Switch_h_idx_2] = (real_T)b[rtb_Switch_h_idx_2];
    }
  } else if (runConfig.nRobots == 3.0) {
    /* '<S21>:1:10' */
    /* '<S21>:1:11' */
    for (rtb_Switch_h_idx_2 = 0; rtb_Switch_h_idx_2 < 24; rtb_Switch_h_idx_2++)
    {
      rtb_D[rtb_Switch_h_idx_2] = (real_T)c[rtb_Switch_h_idx_2];
    }
  } else if (runConfig.nRobots == 2.0) {
    /* '<S21>:1:12' */
    /* '<S21>:1:13' */
    for (rtb_Switch_h_idx_2 = 0; rtb_Switch_h_idx_2 < 24; rtb_Switch_h_idx_2++)
    {
      rtb_D[rtb_Switch_h_idx_2] = (real_T)d[rtb_Switch_h_idx_2];
    }
  } else {
    /* '<S21>:1:15' */
    memset(&rtb_D[0], 0, 24U * sizeof(real_T));
  }

  /* End of MATLAB Function: '<S10>/Incidence Matrix' */

  /* Gain: '<S44>/Gain1' incorporates:
   *  Constant: '<S10>/Formation Rotation'
   */
  /*   */
  /*  elseif numberOfAgents == 3 */
  /*      D = [-1 1 0;1 0 -1; 0 -1 1; 0 0 0]; */
  /*  elseif numberOfAgents == 2 */
  /*      D = [-1 0 0;1 0 0; 0 0 0; 0 0 0]; */
  /*  else */
  /*      D = zeros(4,3); */
  /*  end */
  rtb_complete = 0.017453292519943295 * runConfig.formationRotation;

  /* MultiPortSwitch: '<S20>/Multiport Switch' incorporates:
   *  Constant: '<S10>/Active Formation'
   *  Constant: '<S45>/Constant'
   *  Constant: '<S47>/Constant'
   *  Constant: '<S49>/Constant'
   *  Constant: '<S50>/Constant'
   *  Constant: '<S51>/Constant'
   *  Constant: '<S52>/Constant'
   *  Constant: '<S53>/Constant'
   */
  switch (runConfig.formation) {
   case Single:
    memcpy(&rtb_MultiportSwitch[0], (real_T *)rtCP_Constant_Value, sizeof(real_T)
           << 3U);
    break;

   case TwoLine:
    memcpy(&rtb_MultiportSwitch[0], (real_T *)rtCP_Constant_Value_k, sizeof
           (real_T) << 3U);
    break;

   case Line:
    memcpy(&rtb_MultiportSwitch[0], (real_T *)rtCP_Constant_Value_i, sizeof
           (real_T) << 3U);
    break;

   case Triangle:
    memcpy(&rtb_MultiportSwitch[0], (real_T *)rtCP_Constant_Value_f, sizeof
           (real_T) << 3U);
    break;

   case Square:
    memcpy(&rtb_MultiportSwitch[0], (real_T *)rtCP_Constant_Value_c, sizeof
           (real_T) << 3U);
    break;

   case RotatedSquare:
    memcpy(&rtb_MultiportSwitch[0], (real_T *)rtCP_Constant_Value_d, sizeof
           (real_T) << 3U);
    break;

   default:
    memcpy(&rtb_MultiportSwitch[0], (real_T *)rtCP_Constant_Value_m, sizeof
           (real_T) << 3U);
    break;
  }

  /* End of MultiPortSwitch: '<S20>/Multiport Switch' */

  /* MATLAB Function: '<S20>/Rotate' */
  /* MATLAB Function 'Controller/Formation speed controller/Formation Selection/Rotate': '<S54>:1' */
  /*  Find angle */
  /* '<S54>:1:9' */
  memset(&rtb_rotated_formation[0], 0, sizeof(real_T) << 3U);

  /* '<S54>:1:11' */
  for (iy = 0; iy < 4; iy++) {
    /* '<S54>:1:11' */
    /* '<S54>:1:12' */
    /* '<S54>:1:21' */
    rtb_rotated_formation[iy << 1] = 0.0;
    rtb_rotated_formation[iy << 1] += rtb_MultiportSwitch[iy << 1] * cos
      (rtb_complete);
    rtb_rotated_formation[iy << 1] += rtb_MultiportSwitch[(iy << 1) + 1] * -sin
      (rtb_complete);
    rtb_rotated_formation[1 + (iy << 1)] = 0.0;
    rtb_rotated_formation[1 + (iy << 1)] = rtb_rotated_formation[(iy << 1) + 1]
      + rtb_MultiportSwitch[iy << 1] * sin(rtb_complete);
    rtb_rotated_formation[1 + (iy << 1)] = rtb_MultiportSwitch[(iy << 1) + 1] *
      cos(rtb_complete) + rtb_rotated_formation[(iy << 1) + 1];

    /* '<S54>:1:11' */
  }

  /* End of MATLAB Function: '<S20>/Rotate' */

  /* MATLAB Function: '<S25>/Generate z' */
  Controller_Generatez(rtb_D, rtb_rotated_formation, &Controller_B.sf_Generatez);

  /* Outputs for Iterator SubSystem: '<S10>/camPoint 2 double' incorporates:
   *  ForEach: '<S24>/For Each'
   */
  for (ForEach_itr = 0; ForEach_itr < 4; ForEach_itr++) {
    /* ForEachSliceSelector: '<S24>/ImpSel_InsertedFor_In1_at_outport_0' incorporates:
     *  Inport: '<Root>/all_robots'
     */
    rtb_ImpSel_InsertedFor_In1_at_0 = Controller_U.all_robots[ForEach_itr]
      .point[0];
    rtb_ImpSel_InsertedFor_In1_at_1 = Controller_U.all_robots[ForEach_itr]
      .point[1];

    /* Delay: '<S66>/Delay' */
    /* MATLAB Function 'camPoint -> double/Select point': '<S67>:1' */
    /* '<S67>:1:4' */
    rtb_Delay_l = Controller_DWork.CoreSubsys_p[ForEach_itr].Delay_DSTATE[0];

    /* Delay: '<S66>/Delay1' */
    rtb_Delay1_n = Controller_DWork.CoreSubsys_p[ForEach_itr].Delay1_DSTATE;

    /* Delay: '<S66>/Delay2' */
    rtb_Delay2_o = Controller_DWork.CoreSubsys_p[ForEach_itr].Delay2_DSTATE[0];

    /* Delay: '<S66>/Delay3' */
    rtb_Delay3_k = Controller_DWork.CoreSubsys_p[ForEach_itr].Delay3_DSTATE[0];

    /* MATLAB Function: '<S66>/Running Average' */
    Controller_RunningAverage((CameraInputPoint *)
      (&Controller_rtZCameraInputPoint), &rtb_Delay1_n, &rtb_Delay_l,
      &rtb_Delay2_o, &rtb_Delay3_k, &Controller_B.CoreSubsys_p[ForEach_itr].
      sf_RunningAverage, &Controller_DWork.CoreSubsys_p[ForEach_itr].
      sf_RunningAverage);

    /* Update for Delay: '<S66>/Delay' */
    Controller_DWork.CoreSubsys_p[ForEach_itr].Delay_DSTATE[0] =
      Controller_DWork.CoreSubsys_p[ForEach_itr].Delay_DSTATE[1];
    Controller_DWork.CoreSubsys_p[ForEach_itr].Delay_DSTATE[1] =
      Controller_rtZCameraInputPoint;

    /* Update for Delay: '<S66>/Delay1' */
    Controller_DWork.CoreSubsys_p[ForEach_itr].Delay1_DSTATE =
      Controller_rtZCameraInputPoint;

    /* Update for Delay: '<S66>/Delay2' */
    Controller_DWork.CoreSubsys_p[ForEach_itr].Delay2_DSTATE[0] =
      Controller_DWork.CoreSubsys_p[ForEach_itr].Delay2_DSTATE[1];
    Controller_DWork.CoreSubsys_p[ForEach_itr].Delay2_DSTATE[1] =
      Controller_DWork.CoreSubsys_p[ForEach_itr].Delay2_DSTATE[2];
    Controller_DWork.CoreSubsys_p[ForEach_itr].Delay2_DSTATE[2] =
      Controller_rtZCameraInputPoint;

    /* Update for Delay: '<S66>/Delay3' */
    Controller_DWork.CoreSubsys_p[ForEach_itr].Delay3_DSTATE[0] =
      Controller_DWork.CoreSubsys_p[ForEach_itr].Delay3_DSTATE[1];
    Controller_DWork.CoreSubsys_p[ForEach_itr].Delay3_DSTATE[1] =
      Controller_DWork.CoreSubsys_p[ForEach_itr].Delay3_DSTATE[2];
    Controller_DWork.CoreSubsys_p[ForEach_itr].Delay3_DSTATE[2] =
      Controller_DWork.CoreSubsys_p[ForEach_itr].Delay3_DSTATE[3];
    Controller_DWork.CoreSubsys_p[ForEach_itr].Delay3_DSTATE[3] =
      Controller_rtZCameraInputPoint;

    /* ForEachSliceAssignment: '<S24>/ImpAsg_InsertedFor_Out1_at_inport_0' incorporates:
     *  MATLAB Function: '<S65>/Select point'
     */
    rtb_ImpAsg_InsertedFor_Out1_at_[ForEach_itr << 1] =
      rtb_ImpSel_InsertedFor_In1_at_0;
    rtb_ImpAsg_InsertedFor_Out1_at_[1 + (ForEach_itr << 1)] =
      rtb_ImpSel_InsertedFor_In1_at_1;
  }

  /* End of Outputs for SubSystem: '<S10>/camPoint 2 double' */

  /* MATLAB Function: '<S10>/Concat' incorporates:
   *  Inport: '<Root>/agent_index'
   */
  /* MATLAB Function 'Controller/Formation speed controller/Concat': '<S18>:1' */
  /* '<S18>:1:4' */
  memcpy(&rtb_concated_pos[0], &rtb_ImpAsg_InsertedFor_Out1_at_[0], sizeof
         (real_T) << 3U);

  /* '<S18>:1:5' */
  rtb_concated_pos[(Controller_U.agent_index - 1) << 1] =
    Controller_Y.current_pos[0];
  rtb_concated_pos[1 + ((Controller_U.agent_index - 1) << 1)] =
    Controller_Y.current_pos[1];

  /* MATLAB Function: '<S26>/Generate z' */
  Controller_Generatez(rtb_D, rtb_concated_pos, &Controller_B.sf_Generatez_h);

  /* MATLAB Function: '<S31>/Passitivity formation' */
  /* MATLAB Function 'Controller/Formation speed controller/Controller/Reach Formation/Passitivity formation': '<S41>:1' */
  /*  3 robots */
  /*  Number of links */
  /* '<S41>:1:13' */
  for (rtb_Switch_h_idx_2 = 0; rtb_Switch_h_idx_2 < 12; rtb_Switch_h_idx_2++) {
    z_tilde[rtb_Switch_h_idx_2] =
      Controller_B.sf_Generatez_h.z[rtb_Switch_h_idx_2] -
      Controller_B.sf_Generatez.z[rtb_Switch_h_idx_2];
  }

  /* '<S41>:1:14' */
  rtb_formation_reached = 1;

  /* '<S41>:1:15' */
  iy = 0;
  rtb_LogicalOperator = FALSE;
  while ((!rtb_LogicalOperator) && (iy < 6)) {
    /* '<S41>:1:15' */
    if (fabs(z_tilde[iy]) > 0.03) {
      /* '<S41>:1:16' */
      /* '<S41>:1:17' */
      rtb_formation_reached = 0;
      rtb_LogicalOperator = TRUE;
    } else {
      /* '<S41>:1:15' */
      iy++;
    }
  }

  /* formation_reached = all(z_tilde < 0.02); */
  /*  Example on u creation */
  /* '<S41>:1:30' */
  /* '<S41>:1:32' */
  iy = -1;
  for (ixstart = 0; ixstart < 6; ixstart++) {
    for (rtb_Switch_h_idx_2 = 0; rtb_Switch_h_idx_2 < 2; rtb_Switch_h_idx_2++) {
      for (rtb_Switch_h_idx_0 = 0; rtb_Switch_h_idx_0 < 4; rtb_Switch_h_idx_0++)
      {
        iy++;
        b_K[iy] = rtb_D[(ixstart << 2) + rtb_Switch_h_idx_0] * (real_T)
          B[rtb_Switch_h_idx_2 << 1];
        iy++;
        b_K[iy] = rtb_D[(ixstart << 2) + rtb_Switch_h_idx_0] * (real_T)B
          [(rtb_Switch_h_idx_2 << 1) + 1];
      }
    }
  }

  for (rtb_Switch_h_idx_2 = 0; rtb_Switch_h_idx_2 < 12; rtb_Switch_h_idx_2++) {
    for (rtb_Switch_h_idx_0 = 0; rtb_Switch_h_idx_0 < 8; rtb_Switch_h_idx_0++) {
      b_K_0[rtb_Switch_h_idx_0 + (rtb_Switch_h_idx_2 << 3)] = -b_K
        [(rtb_Switch_h_idx_2 << 3) + rtb_Switch_h_idx_0];
    }
  }

  memcpy(&z_tilde_0[0], &z_tilde[0], 12U * sizeof(real_T));

  /* '<S41>:1:34' */
  for (rtb_Switch_h_idx_2 = 0; rtb_Switch_h_idx_2 < 8; rtb_Switch_h_idx_2++) {
    rtb_MultiportSwitch[rtb_Switch_h_idx_2] = 0.0;
    for (rtb_Switch_h_idx_0 = 0; rtb_Switch_h_idx_0 < 12; rtb_Switch_h_idx_0++)
    {
      rtb_MultiportSwitch[rtb_Switch_h_idx_2] += b_K_0[(rtb_Switch_h_idx_0 << 3)
        + rtb_Switch_h_idx_2] * z_tilde_0[rtb_Switch_h_idx_0];
    }

    rtb_ImpAsg_InsertedFor_Out1_at_[rtb_Switch_h_idx_2] =
      rtb_MultiportSwitch[rtb_Switch_h_idx_2];
  }

  /* Sum: '<S19>/Sum1' incorporates:
   *  Gain: '<S31>/Gain'
   *  Inport: '<Root>/agent_index'
   *  MATLAB Function: '<S31>/Passitivity formation'
   */
  /* u = u_tmp; % Set u out as column vector */
  /*  out put the correct agent */
  /* '<S41>:1:38' */
  rtb_Sum1[0] = rtb_ImpAsg_InsertedFor_Out1_at_[(Controller_U.agent_index - 1) <<
    1] * Kp_formation + rtb_means[0];
  rtb_Sum1[1] = rtb_ImpAsg_InsertedFor_Out1_at_[((Controller_U.agent_index - 1) <<
    1) + 1] * Kp_formation + rtb_means[1];

  /* Outputs for Iterator SubSystem: '<S10>/Running Average' incorporates:
   *  ForEach: '<S23>/For Each'
   */
  for (ForEach_itr_c = 0; ForEach_itr_c < 3; ForEach_itr_c++) {
    /* ForEachSliceSelector: '<S23>/ImpSel_InsertedFor_In1_at_outport_0' incorporates:
     *  Inport: '<Root>/obstacles'
     */
    rtb_ImpSel_InsertedFor_In1_a_ob = Controller_U.obstacles[ForEach_itr_c];

    /* Delay: '<S63>/Delay1' */
    rtb_Delay1_j = Controller_DWork.CoreSubsys[ForEach_itr_c].Delay1_DSTATE;

    /* Delay: '<S63>/Delay' */
    rtb_Delay_f = Controller_DWork.CoreSubsys[ForEach_itr_c].Delay_DSTATE[0];

    /* Delay: '<S63>/Delay2' */
    rtb_Delay2_e = Controller_DWork.CoreSubsys[ForEach_itr_c].Delay2_DSTATE[0];

    /* Delay: '<S63>/Delay3' */
    rtb_Delay3_l = Controller_DWork.CoreSubsys[ForEach_itr_c].Delay3_DSTATE[0];

    /* MATLAB Function: '<S63>/Running Average' */
    Controller_RunningAverage(&rtb_ImpSel_InsertedFor_In1_a_ob, &rtb_Delay1_j,
      &rtb_Delay_f, &rtb_Delay2_e, &rtb_Delay3_l,
      &Controller_B.CoreSubsys[ForEach_itr_c].sf_RunningAverage,
      &Controller_DWork.CoreSubsys[ForEach_itr_c].sf_RunningAverage);

    /* Update for Delay: '<S63>/Delay1' */
    Controller_DWork.CoreSubsys[ForEach_itr_c].Delay1_DSTATE =
      rtb_ImpSel_InsertedFor_In1_a_ob;

    /* Update for Delay: '<S63>/Delay' */
    Controller_DWork.CoreSubsys[ForEach_itr_c].Delay_DSTATE[0] =
      Controller_DWork.CoreSubsys[ForEach_itr_c].Delay_DSTATE[1];
    Controller_DWork.CoreSubsys[ForEach_itr_c].Delay_DSTATE[1] =
      rtb_ImpSel_InsertedFor_In1_a_ob;

    /* Update for Delay: '<S63>/Delay2' */
    Controller_DWork.CoreSubsys[ForEach_itr_c].Delay2_DSTATE[0] =
      Controller_DWork.CoreSubsys[ForEach_itr_c].Delay2_DSTATE[1];
    Controller_DWork.CoreSubsys[ForEach_itr_c].Delay2_DSTATE[1] =
      Controller_DWork.CoreSubsys[ForEach_itr_c].Delay2_DSTATE[2];
    Controller_DWork.CoreSubsys[ForEach_itr_c].Delay2_DSTATE[2] =
      rtb_ImpSel_InsertedFor_In1_a_ob;

    /* Update for Delay: '<S63>/Delay3' */
    Controller_DWork.CoreSubsys[ForEach_itr_c].Delay3_DSTATE[0] =
      Controller_DWork.CoreSubsys[ForEach_itr_c].Delay3_DSTATE[1];
    Controller_DWork.CoreSubsys[ForEach_itr_c].Delay3_DSTATE[1] =
      Controller_DWork.CoreSubsys[ForEach_itr_c].Delay3_DSTATE[2];
    Controller_DWork.CoreSubsys[ForEach_itr_c].Delay3_DSTATE[2] =
      Controller_DWork.CoreSubsys[ForEach_itr_c].Delay3_DSTATE[3];
    Controller_DWork.CoreSubsys[ForEach_itr_c].Delay3_DSTATE[3] =
      rtb_ImpSel_InsertedFor_In1_a_ob;

    /* ForEachSliceAssignment: '<S23>/ImpAsg_InsertedFor_Out1_at_inport_0' */
    rtb_ImpAsg_InsertedFor_Out1_a_k[ForEach_itr_c << 1] =
      Controller_B.CoreSubsys[ForEach_itr_c].sf_RunningAverage.means[0];
    rtb_ImpAsg_InsertedFor_Out1_a_k[1 + (ForEach_itr_c << 1)] =
      Controller_B.CoreSubsys[ForEach_itr_c].sf_RunningAverage.means[1];
  }

  /* End of Outputs for SubSystem: '<S10>/Running Average' */

  /* MATLAB Function: '<S30>/Obstacle Avoidance' */
  rtb_complete = 0.5;

  /* MATLAB Function 'Control/Behavioral/Obstacle Avoidance/Obstacle Avoidance': '<S37>:1' */
  /*  This is the behaviour for obstacle avoidance */
  /*  Find the nearest obstacle */
  /* '<S37>:1:19' */
  rtb_means[0] = rtb_ImpAsg_InsertedFor_Out1_a_k[0];
  rtb_means[1] = rtb_ImpAsg_InsertedFor_Out1_a_k[1];

  /* '<S37>:1:20' */
  for (iy = 0; iy < 3; iy++) {
    /* '<S37>:1:20' */
    tmp_5[0] = Controller_Y.current_pos[0] - rtb_means[0];
    tmp_5[1] = Controller_Y.current_pos[1] - rtb_means[1];
    tmp_6[0] = Controller_Y.current_pos[0] - rtb_ImpAsg_InsertedFor_Out1_a_k[iy <<
      1];
    tmp_6[1] = Controller_Y.current_pos[1] - rtb_ImpAsg_InsertedFor_Out1_a_k[(iy
      << 1) + 1];
    if (fkfcopppfcbigdba_norm(tmp_5) > fkfcopppfcbigdba_norm(tmp_6)) {
      /* '<S37>:1:21' */
      /* '<S37>:1:22' */
      rtb_means[0] = rtb_ImpAsg_InsertedFor_Out1_a_k[iy << 1];
      rtb_means[1] = rtb_ImpAsg_InsertedFor_Out1_a_k[(iy << 1) + 1];
    }

    /* '<S37>:1:20' */
  }

  /*  Always same obstacle for now */
  /*  Other Setups */
  /* % Calculations */
  /*  Control signal */
  /* '<S37>:1:39' */
  tmp_4[0] = Controller_Y.current_pos[0] - rtb_means[0];
  tmp_4[1] = Controller_Y.current_pos[1] - rtb_means[1];
  sigma = fkfcopppfcbigdba_norm(tmp_4);

  /* '<S37>:1:40' */
  /*  Angle from vehicle to obstacle */
  /* '<S37>:1:43' */
  /*  Calculate Jacobian */
  /* '<S37>:1:46' */
  J[0] = (Controller_Y.current_pos[0] - rtb_means[0]) / sigma;
  J[1] = (Controller_Y.current_pos[1] - rtb_means[1]) / sigma;

  /*  Check if we are on the circle */
  /*  Check if we are inside the circle */
  if (sigma < 0.2) {
    /* '<S37>:1:54' */
    /* '<S37>:1:55' */
    rtb_complete = 10.0;
  }

  /*  Only activate if we are within a given distance to the obstacle */
  if (sigma > 0.30000000000000004) {
    /* '<S37>:1:60' */
    /* '<S37>:1:61' */
    J[0] = 0.0;
    J[1] = 0.0;
  }

  /*  Calculate behavioral speed */
  /* '<S37>:1:65' */
  hlfkknohcjmongdj_myInv(J, rtb_v_o);

  /*  Calculate null-space */
  /* '<S37>:1:68' */
  rtb_v_o[0] = rtb_v_o[0] * rtb_complete * (0.2 - sigma);
  rtb_v_o[1] = rtb_v_o[1] * rtb_complete * (0.2 - sigma);
  rtb_obs_distance = sigma;

  /* MATLAB Function: '<S29>/Obstacle Avoidance' incorporates:
   *  Inport: '<Root>/agent_index'
   */
  rtb_complete = 0.5;

  /* MATLAB Function 'Controller/Formation speed controller/Controller/Collision Avoidance/Obstacle Avoidance': '<S33>:1' */
  /*  Decleare the matrix variable size, only column */
  /*  pos is always relative 0 0 */
  /* '<S33>:1:7' */
  /*  The objective here is to output the distance to every other agent that */
  /*  this agent is a neighbour to */
  /*  First, find which links that belong to this agent */
  /* '<S33>:1:18' */
  /* '<S33>:1:19' */
  /*  then the obstacles are simply these columns in the z matrix */
  for (rtb_Switch_h_idx_2 = 0; rtb_Switch_h_idx_2 < 6; rtb_Switch_h_idx_2++) {
    tmp_2[rtb_Switch_h_idx_2] = (rtb_D[((rtb_Switch_h_idx_2 << 2) +
      Controller_U.agent_index) - 1] == 1.0);
    tmp_3[rtb_Switch_h_idx_2] = (rtb_D[((rtb_Switch_h_idx_2 << 2) +
      Controller_U.agent_index) - 1] == -1.0);
  }

  ngdbnoppcjeccbaa_eml_li_find(tmp_2, tmp_data, tmp_sizes);
  ngdbnoppcjeccbaa_eml_li_find(tmp_3, tmp_data_0, tmp_sizes_0);
  rtb_Switch_h_idx_0 = tmp_sizes[1];
  ixstart = tmp_sizes_0[1];
  b_sizes_idx = tmp_sizes[1] + tmp_sizes_0[1];
  for (rtb_Switch_h_idx_2 = 0; rtb_Switch_h_idx_2 < rtb_Switch_h_idx_0;
       rtb_Switch_h_idx_2++) {
    b_data[rtb_Switch_h_idx_2 << 1] = -Controller_B.sf_Generatez_h.z
      [(tmp_data[rtb_Switch_h_idx_2] - 1) << 1];
    b_data[1 + (rtb_Switch_h_idx_2 << 1)] = -Controller_B.sf_Generatez_h.z
      [((tmp_data[rtb_Switch_h_idx_2] - 1) << 1) + 1];
  }

  for (rtb_Switch_h_idx_2 = 0; rtb_Switch_h_idx_2 < ixstart; rtb_Switch_h_idx_2
       ++) {
    b_data[(rtb_Switch_h_idx_2 + tmp_sizes[1]) << 1] =
      Controller_B.sf_Generatez_h.z[(tmp_data_0[rtb_Switch_h_idx_2] - 1) << 1];
    b_data[1 + ((rtb_Switch_h_idx_2 + tmp_sizes[1]) << 1)] =
      Controller_B.sf_Generatez_h.z[((tmp_data_0[rtb_Switch_h_idx_2] - 1) << 1)
      + 1];
  }

  /* '<S33>:1:22' */
  if (b_sizes_idx < 1) {
    /* '<S33>:1:24' */
    /* '<S33>:1:25' */
    rtb_v_i[0] = 0.0;
    rtb_v_i[1] = 0.0;

    /* '<S33>:1:26' */
    rtb_N_k_idx = 0.0;
    rtb_N_k_idx_0 = 0.0;
    rtb_complete = 1.0;
    rtb_N_k_idx_1 = 1.0;

    /* '<S33>:1:27' */
    /* '<S33>:1:28' */
    sigma = 0.0;

    /*  Distance to nearest obstacle, set to zero */
    /*  Since v = 0, this parameter is not used by task */
    /*  activator */
  } else {
    /*  This is the behaviour for obstacle avoidance */
    /*  Find the nearest obstacle */
    /* '<S33>:1:39' */
    rtb_means[0] = b_data[0];
    rtb_means[1] = b_data[1];

    /* '<S33>:1:40' */
    for (iy = 0; iy < b_sizes_idx; iy++) {
      /* '<S33>:1:40' */
      tmp_0[0] = 0.0 - rtb_means[0];
      tmp_0[1] = 0.0 - rtb_means[1];
      tmp_1[0] = 0.0 - b_data[iy << 1];
      tmp_1[1] = 0.0 - b_data[(iy << 1) + 1];
      if (fkfcopppfcbigdba_norm(tmp_0) > fkfcopppfcbigdba_norm(tmp_1)) {
        /* '<S33>:1:41' */
        /* '<S33>:1:42' */
        rtb_means[0] = b_data[iy << 1];
        rtb_means[1] = b_data[(iy << 1) + 1];
      }

      /* '<S33>:1:40' */
    }

    /*  Always same obstacle for now */
    /*  Other Setups */
    /* % Calculations */
    /*  Control signal */
    /* '<S33>:1:59' */
    tmp[0] = 0.0 - rtb_means[0];
    tmp[1] = 0.0 - rtb_means[1];
    sigma = fkfcopppfcbigdba_norm(tmp);

    /* '<S33>:1:60' */
    /*  Angle from vehicle to obstacle */
    /* '<S33>:1:63' */
    /*  Calculate Jacobian */
    /* '<S33>:1:67' */
    J_0[0] = (0.0 - rtb_means[0]) / sigma;
    J_0[1] = (0.0 - rtb_means[1]) / sigma;

    /*  Check if we are on the circle */
    /*  Check if we are inside the circle */
    if (sigma < 0.38) {
      /* '<S33>:1:75' */
      /* '<S33>:1:76' */
      rtb_complete = 10.0;
    }

    /*  Only activate if we are within a given distance to the obstacle */
    if (sigma > 0.57000000000000006) {
      /* '<S33>:1:81' */
      /* '<S33>:1:82' */
      J_0[0] = 0.0;
      J_0[1] = 0.0;
    }

    /*  Calculate behavioral speed */
    /* '<S33>:1:87' */
    eknoaiecimohkfcj_myInv(J_0, rtb_v_i);
    rtb_v_i[0] = rtb_v_i[0] * rtb_complete * (0.38 - sigma);
    rtb_v_i[1] = rtb_v_i[1] * rtb_complete * (0.38 - sigma);

    /*  Calculate null-space */
    /* '<S33>:1:91' */
    eknoaiecimohkfcj_myInv(J_0, tmp_4);
    rtb_complete = 1.0 - tmp_4[0] * J_0[0];
    rtb_N_k_idx_0 = 0.0 - tmp_4[0] * J_0[1];
    rtb_N_k_idx = 0.0 - tmp_4[1] * J_0[0];
    rtb_N_k_idx_1 = 1.0 - tmp_4[1] * J_0[1];
  }

  rtb_obs_distance_d = sigma;

  /* End of MATLAB Function: '<S29>/Obstacle Avoidance' */

  /* MATLAB Function: '<S34>/Task activator' */
  Controller_Taskactivator(rtb_v_i, rtb_obs_distance_d, rtb_Sum1,
    &Controller_B.sf_Taskactivator, 0.38);

  /* Switch: '<S29>/Switch' incorporates:
   *  Product: '<S29>/Project Nullspace'
   *  Sum: '<S29>/Sum'
   */
  if (Controller_B.sf_Taskactivator.active != 0.0) {
    rtb_Switch[0] = (rtb_complete * rtb_Sum1[0] + rtb_N_k_idx_0 * rtb_Sum1[1]) +
      rtb_v_i[0];
    rtb_Switch[1] = (rtb_N_k_idx * rtb_Sum1[0] + rtb_N_k_idx_1 * rtb_Sum1[1]) +
      rtb_v_i[1];
  } else {
    rtb_Switch[0] = rtb_Sum1[0];
    rtb_Switch[1] = rtb_Sum1[1];
  }

  /* End of Switch: '<S29>/Switch' */

  /* MATLAB Function: '<S38>/Task activator' */
  Controller_Taskactivator(rtb_v_o, rtb_obs_distance, rtb_Switch,
    &Controller_B.sf_Taskactivator_e, 0.2);

  /* Logic: '<S30>/Logical Operator' incorporates:
   *  Constant: '<S19>/If force obstacle deactivate'
   *  Constant: '<S36>/Constant'
   *  RelationalOperator: '<S36>/Compare'
   */
  rtb_LogicalOperator = ((Controller_B.sf_Taskactivator_e.active != 0.0) &&
    (!runConfig.forceObstacleDeactivate));

  /* Switch: '<S30>/Switch' incorporates:
   *  DataTypeConversion: '<S30>/Data Type Conversion'
   *  MATLAB Function: '<S30>/Obstacle Avoidance'
   *  Product: '<S30>/Project Nullspace'
   *  Sum: '<S30>/Sum'
   */
  if (rtb_LogicalOperator) {
    /* MATLAB Function: '<S30>/Obstacle Avoidance' */
    hlfkknohcjmongdj_myInv(J, tmp_4);
    rtb_complete = ((1.0 - tmp_4[0] * J[0]) * rtb_Switch[0] + (0.0 - tmp_4[0] *
      J[1]) * rtb_Switch[1]) + rtb_v_o[0];
    rtb_N_k_idx_0 = ((0.0 - tmp_4[1] * J[0]) * rtb_Switch[0] + (1.0 - tmp_4[1] *
      J[1]) * rtb_Switch[1]) + rtb_v_o[1];
  } else {
    rtb_complete = rtb_Switch[0];
    rtb_N_k_idx_0 = rtb_Switch[1];
  }

  /* End of Switch: '<S30>/Switch' */

  /* DataStoreWrite: '<S4>/Data Store Write3' incorporates:
   *  DataTypeConversion: '<S30>/Data Type Conversion'
   */
  logEntry[0] = rtb_Gain_e;
  logEntry[1] = rtb_Sum1[0];
  logEntry[2] = rtb_Sum1[1];
  logEntry[3] = rtb_v_o[0];
  logEntry[4] = rtb_v_o[1];
  logEntry[5] = rtb_complete;
  logEntry[6] = rtb_N_k_idx_0;
  logEntry[7] = (real_T)rtb_LogicalOperator;
  logEntry[8] = 0.0;
  logEntry[9] = 0.0;

  /* MATLAB Function: '<S11>/Simple PP guiadnce' incorporates:
   *  Constant: '<S70>/Constant'
   */
  /* MATLAB Function 'Controller/Observer Demo Controller/Simple PP guiadnce': '<S69>:1' */
  if (Controller_DWork.index == 5.0) {
    /* '<S69>:1:10' */
    /* '<S69>:1:11' */
    Controller_DWork.index = 1.0;
  }

  /* '<S69>:1:15' */
  /* '<S69>:1:23' */
  rtb_Switch_h_idx_2 = (int32_T)Controller_DWork.index;
  rtb_means[0] = rtCP_Constant_Value_e[((rtb_Switch_h_idx_2 - 1) << 1)] -
    Controller_Y.current_pos[0];
  rtb_means[1] = rtCP_Constant_Value_e[((rtb_Switch_h_idx_2 - 1) << 1) + 1] -
    Controller_Y.current_pos[1];

  /* '<S69>:1:25' */
  /*  Check if we are past */
  if (fkfcopppfcbigdba_norm(rtb_means) < 0.02) {
    /* '<S69>:1:32' */
    /* '<S69>:1:33' */
    Controller_DWork.index++;
  }

  /* MultiPortSwitch: '<S2>/Multiport Switch' incorporates:
   *  Constant: '<S2>/Constant'
   *  MATLAB Function: '<S11>/Simple PP guiadnce'
   */
  if ((int32_T)controllerMethod == 1) {
    rtb_complete = 0.0 * rtb_means[1] + rtb_means[0];
    rtb_N_k_idx_0 = 0.0 * rtb_means[0] + rtb_means[1];
  }

  /* End of MultiPortSwitch: '<S2>/Multiport Switch' */

  /* MATLAB Function: '<S13>/R^b_n' */
  /* MATLAB Function 'Controller/ned2body/R^b_n': '<S73>:1' */
  /* '<S73>:1:6' */
  rtb_means[0] = cos(rtb_Observer_o2) * rtb_complete + sin(rtb_Observer_o2) *
    rtb_N_k_idx_0;
  rtb_means[1] = -sin(rtb_Observer_o2) * rtb_complete;
  rtb_means[1] += cos(rtb_Observer_o2) * rtb_N_k_idx_0;

  /* MATLAB Function: '<S13>/normalize max speed' incorporates:
   *  Constant: '<S13>/Max speed'
   */
  /* MATLAB Function 'Controller/ned2body/normalize max speed': '<S74>:1' */
  if (fkfcopppfcbigdba_norm(rtb_means) > 0.09) {
    /* '<S74>:1:6' */
    /* '<S74>:1:7' */
    rtb_complete = fkfcopppfcbigdba_norm(rtb_means);
    rtb_means[0] = rtb_means[0] * 0.09 / rtb_complete;
    rtb_means[1] = rtb_means[1] * 0.09 / rtb_complete;
  } else {
    /* '<S74>:1:9' */
  }

  /* End of MATLAB Function: '<S13>/normalize max speed' */

  /* Saturate: '<S9>/Saturation2' incorporates:
   *  Constant: '<Root>/Heading setpoint'
   */
  /* MATLAB Function 'Controller/Angle Controller/NOrmalize angle2': '<S15>:1' */
  /* % NORMALIZE ANGLE */
  /* '<S15>:1:6' */
  if (Setpoint >= 180) {
    tmp_7 = 180;
  } else if (Setpoint <= -179) {
    tmp_7 = -179;
  } else {
    tmp_7 = Setpoint;
  }

  /* MATLAB Function: '<S9>/NOrmalize angle2' incorporates:
   *  Gain: '<S16>/Gain'
   *  Saturate: '<S9>/Saturation2'
   *  Sum: '<S9>/Sum2'
   */
  rtb_complete = rt_remd_snf(57.295779513082323 * rtb_Observer_o2 - (real_T)
    tmp_7, 360.0);
  if (rtb_complete > 180.0) {
    /* '<S15>:1:9' */
    /* '<S15>:1:10' */
    rtb_complete -= 360.0;
  } else {
    if (rtb_complete <= -180.0) {
      /* '<S15>:1:11' */
      /* '<S15>:1:12' */
      rtb_complete += 360.0;
    }
  }

  /* End of MATLAB Function: '<S9>/NOrmalize angle2' */

  /* Gain: '<S14>/Gain1' incorporates:
   *  Gain: '<S9>/Kp'
   */
  r = -Kp * 0.1 * rtb_complete * 0.017453292519943295;

  /* Switch: '<Root>/Switch' incorporates:
   *  Abs: '<S7>/Abs'
   *  Constant: '<S5>/Constant'
   *  DataTypeConversion: '<S1>/Data Type Conversion1'
   *  Lookup_n-D: '<S7>/Omega - servo'
   *  Product: '<S7>/Matrix Multiply'
   *  RelationalOperator: '<S5>/Compare'
   */
  if (!Controller_Y.observer_valid) {
    rtb_Switch_h_idx_0 = 0;
    ixstart = 0;
    rtb_Switch_h_idx_2 = 0;
  } else {
    /* Gain: '<S1>/inv(T)' incorporates:
     *  SignalConversion: '<S1>/TmpSignal ConversionAtinv(T)Inport1'
     */
    for (rtb_Switch_h_idx_2 = 0; rtb_Switch_h_idx_2 < 3; rtb_Switch_h_idx_2++) {
      rtb_MatrixMultiply[rtb_Switch_h_idx_2] = rtCP_invT_Gain[rtb_Switch_h_idx_2
        + 6] * r + (rtCP_invT_Gain[rtb_Switch_h_idx_2 + 3] * rtb_means[1] +
                    rtCP_invT_Gain[rtb_Switch_h_idx_2] * rtb_means[0]);
    }

    /* End of Gain: '<S1>/inv(T)' */

    /* Signum: '<S7>/Sign' */
    rtb_complete = rtb_MatrixMultiply[0];
    rtb_N_k_idx_0 = rtb_MatrixMultiply[1];
    rtb_N_k_idx_1 = rtb_MatrixMultiply[2];
    rtb_MatrixMultiply[0] = fabs(rtb_MatrixMultiply[0]);
    rtb_MatrixMultiply[1] = fabs(rtb_MatrixMultiply[1]);

    /* Abs: '<S7>/Abs' */
    rtb_N_k_idx = fabs(rtb_MatrixMultiply[2]);

    /* Lookup_n-D: '<S7>/Omega - servo' */
    sigma = look1_binlcapw(rtb_MatrixMultiply[0U], *(real_T (*)[3])
      rtCP_Omegaservo_bp01Data, *(real_T (*)[3])rtCP_Omegaservo_tableData, 2U);
    rtb_MatrixMultiply[0U] = sigma;

    /* Lookup_n-D: '<S7>/Omega - servo' */
    sigma = look1_binlcapw(rtb_MatrixMultiply[1U], *(real_T (*)[3])
      rtCP_Omegaservo_bp01Data, *(real_T (*)[3])rtCP_Omegaservo_tableData, 2U);
    rtb_MatrixMultiply[1U] = sigma;

    /* Lookup_n-D: '<S7>/Omega - servo' */
    sigma = look1_binlcapw(rtb_N_k_idx, *(real_T (*)[3])rtCP_Omegaservo_bp01Data,
      *(real_T (*)[3])rtCP_Omegaservo_tableData, 2U);

    /* Signum: '<S7>/Sign' */
    if (rtb_complete < 0.0) {
      rtb_complete = -1.0;
    } else if (rtb_complete > 0.0) {
      rtb_complete = 1.0;
    } else {
      if (rtb_complete == 0.0) {
        rtb_complete = 0.0;
      }
    }

    rtb_MatrixMultiply[0] *= rtb_complete;

    /* Signum: '<S7>/Sign' incorporates:
     *  Product: '<S7>/Matrix Multiply'
     */
    if (rtb_N_k_idx_0 < 0.0) {
      rtb_N_k_idx_0 = -1.0;
    } else if (rtb_N_k_idx_0 > 0.0) {
      rtb_N_k_idx_0 = 1.0;
    } else {
      if (rtb_N_k_idx_0 == 0.0) {
        rtb_N_k_idx_0 = 0.0;
      }
    }

    rtb_MatrixMultiply[1] *= rtb_N_k_idx_0;

    /* DataTypeConversion: '<S1>/Data Type Conversion1' incorporates:
     *  Product: '<S7>/Matrix Multiply'
     */
    rtb_complete = floor(rtb_MatrixMultiply[0]);
    if (rtIsNaN(rtb_complete) || rtIsInf(rtb_complete)) {
      rtb_complete = 0.0;
    } else {
      rtb_complete = fmod(rtb_complete, 4.294967296E+9);
    }

    rtb_Switch_h_idx_0 = rtb_complete < 0.0 ? -(int32_T)(uint32_T)-rtb_complete :
      (int32_T)(uint32_T)rtb_complete;

    /* DataTypeConversion: '<S1>/Data Type Conversion1' */
    rtb_complete = floor(rtb_MatrixMultiply[1]);
    if (rtIsNaN(rtb_complete) || rtIsInf(rtb_complete)) {
      rtb_complete = 0.0;
    } else {
      rtb_complete = fmod(rtb_complete, 4.294967296E+9);
    }

    ixstart = rtb_complete < 0.0 ? -(int32_T)(uint32_T)-rtb_complete : (int32_T)
      (uint32_T)rtb_complete;

    /* Signum: '<S7>/Sign' incorporates:
     *  DataTypeConversion: '<S1>/Data Type Conversion1'
     */
    if (rtb_N_k_idx_1 < 0.0) {
      rtb_N_k_idx_1 = -1.0;
    } else if (rtb_N_k_idx_1 > 0.0) {
      rtb_N_k_idx_1 = 1.0;
    } else {
      if (rtb_N_k_idx_1 == 0.0) {
        rtb_N_k_idx_1 = 0.0;
      }
    }

    /* DataTypeConversion: '<S1>/Data Type Conversion1' incorporates:
     *  Product: '<S7>/Matrix Multiply'
     */
    rtb_complete = floor(sigma * rtb_N_k_idx_1);
    if (rtIsNaN(rtb_complete) || rtIsInf(rtb_complete)) {
      rtb_complete = 0.0;
    } else {
      rtb_complete = fmod(rtb_complete, 4.294967296E+9);
    }

    rtb_Switch_h_idx_2 = rtb_complete < 0.0 ? -(int32_T)(uint32_T)-rtb_complete :
      (int32_T)(uint32_T)rtb_complete;
  }

  /* End of Switch: '<Root>/Switch' */

  /* Outport: '<Root>/servo_out' */
  Controller_Y.servo_out[0] = rtb_Switch_h_idx_0;
  Controller_Y.servo_out[1] = ixstart;
  Controller_Y.servo_out[2] = rtb_Switch_h_idx_2;

  /* DataTypeConversion: '<Root>/Data Type Conversion1' */
  rtb_complete = floor(rtb_Gain_e);
  if (rtIsNaN(rtb_complete) || rtIsInf(rtb_complete)) {
    rtb_complete = 0.0;
  } else {
    rtb_complete = fmod(rtb_complete, 65536.0);
  }

  /* Outport: '<Root>/heading' incorporates:
   *  DataTypeConversion: '<Root>/Data Type Conversion1'
   */
  Controller_Y.heading = (int16_T)(rtb_complete < 0.0 ? (int16_T)-(int16_T)
    (uint16_T)-rtb_complete : (int16_T)(uint16_T)rtb_complete);

  /* Outport: '<Root>/formation_reached' */
  Controller_Y.formation_reached = (real_T)rtb_formation_reached;

  /* Outport: '<Root>/common_v' incorporates:
   *  DataTypeConversion: '<Root>/Data Type Conversion3'
   */
  Controller_Y.common_v[0] = (real32_T)rtb_Merge[0];
  Controller_Y.common_v[1] = (real32_T)rtb_Merge[1];

  /* Update for UnitDelay: '<Root>/Unit Delay' */
  /* MATLAB Function 'Controller/Formation speed controller/Controller/Reach Formation/norm': '<S42>:1' */
  /* '<S42>:1:4' */
  Controller_DWork.UnitDelay_DSTATE[0] = rtb_Switch_h_idx_0;
  Controller_DWork.UnitDelay_DSTATE[1] = ixstart;
  Controller_DWork.UnitDelay_DSTATE[2] = rtb_Switch_h_idx_2;

  /* Update for Delay: '<S57>/Delay1' incorporates:
   *  Inport: '<Root>/target'
   */
  Controller_DWork.Delay1_DSTATE = Controller_U.target;

  /* Update for Delay: '<S57>/Delay' incorporates:
   *  Inport: '<Root>/target'
   */
  Controller_DWork.Delay_DSTATE[0] = Controller_DWork.Delay_DSTATE[1];
  Controller_DWork.Delay_DSTATE[1] = Controller_U.target;

  /* Update for Delay: '<S57>/Delay2' incorporates:
   *  Inport: '<Root>/target'
   */
  Controller_DWork.Delay2_DSTATE[0] = Controller_DWork.Delay2_DSTATE[1];
  Controller_DWork.Delay2_DSTATE[1] = Controller_DWork.Delay2_DSTATE[2];
  Controller_DWork.Delay2_DSTATE[2] = Controller_U.target;

  /* Update for Delay: '<S57>/Delay3' incorporates:
   *  Inport: '<Root>/target'
   */
  Controller_DWork.Delay3_DSTATE[0] = Controller_DWork.Delay3_DSTATE[1];
  Controller_DWork.Delay3_DSTATE[1] = Controller_DWork.Delay3_DSTATE[2];
  Controller_DWork.Delay3_DSTATE[2] = Controller_DWork.Delay3_DSTATE[3];
  Controller_DWork.Delay3_DSTATE[3] = Controller_U.target;
}

/* Model initialize function */
void Controller_initialize(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize error status */
  rtmSetErrorStatus(Controller_M, (NULL));

  /* block I/O */
  (void) memset(((void *) &Controller_B), 0,
                sizeof(BlockIO_Controller));

  /* custom signals */
  r = 0.0;

  /* states (dwork) */
  (void) memset((void *)&Controller_DWork, 0,
                sizeof(D_Work_Controller));

  /* exported global states */
  (void) memset(&logEntry, 0,
                10U*sizeof(real_T));

  /* external inputs */
  (void) memset((void *)&Controller_U, 0,
                sizeof(ExternalInputs_Controller));

  /* external outputs */
  (void) memset((void *)&Controller_Y, 0,
                sizeof(ExternalOutputs_Controller));

  /* Model Initialize fcn for ModelReference Block: '<Root>/Observer' */
  Observer_initialize(rtmGetErrorStatusPointer(Controller_M));

  {
    /* local scratch DWork variables */
    int32_T ForEach_itr;
    int32_T ForEach_itr_c;

    /* Start for Iterator SubSystem: '<S10>/camPoint 2 double' */
    for (ForEach_itr = 0; ForEach_itr < 4; ForEach_itr++) {
      /* Start for Iterator SubSystem: '<S10>/camPoint 2 double' */

      /* Start for MATLAB Function: '<S66>/Running Average' */
      Controller_RunningAverage_Start(&Controller_B.CoreSubsys_p[ForEach_itr].
        sf_RunningAverage, &Controller_DWork.CoreSubsys_p[ForEach_itr].
        sf_RunningAverage);

      /* InitializeConditions for MATLAB Function: '<S66>/Running Average' */
      Controller_RunningAverage_Init(&Controller_DWork.CoreSubsys_p[ForEach_itr]
        .sf_RunningAverage);

      /* End of Start for SubSystem: '<S10>/camPoint 2 double' */
    }

    /* End of Start for SubSystem: '<S10>/camPoint 2 double' */
    /* Start for Iterator SubSystem: '<S10>/Running Average' */
    for (ForEach_itr_c = 0; ForEach_itr_c < 3; ForEach_itr_c++) {
      /* Start for Iterator SubSystem: '<S10>/Running Average' */

      /* Start for MATLAB Function: '<S63>/Running Average' */
      Controller_RunningAverage_Start(&Controller_B.CoreSubsys[ForEach_itr_c].
        sf_RunningAverage, &Controller_DWork.CoreSubsys[ForEach_itr_c].
        sf_RunningAverage);

      /* InitializeConditions for MATLAB Function: '<S63>/Running Average' */
      Controller_RunningAverage_Init(&Controller_DWork.CoreSubsys[ForEach_itr_c]
        .sf_RunningAverage);

      /* End of Start for SubSystem: '<S10>/Running Average' */
    }

    /* End of Start for SubSystem: '<S10>/Running Average' */
  }

  {
    /* local scratch DWork variables */
    int32_T ForEach_itr;
    int32_T ForEach_itr_c;

    /* InitializeConditions for ModelReference: '<Root>/Observer' */
    Observer_Init();

    /* InitializeConditions for MATLAB Function: '<S57>/Running Average' */
    Controller_DWork.k = 0.0;

    /* InitializeConditions for MATLAB Function: '<S57>/MATLAB Function' */
    Controller_DWork.lastBeforeComplete_not_empty = FALSE;

    /* InitializeConditions for Iterator SubSystem: '<S10>/camPoint 2 double' */
    for (ForEach_itr = 0; ForEach_itr < 4; ForEach_itr++) {
      /* InitializeConditions for Iterator SubSystem: '<S10>/camPoint 2 double' */

      /* InitializeConditions for MATLAB Function: '<S66>/Running Average' */
      Controller_RunningAverage_Init(&Controller_DWork.CoreSubsys_p[ForEach_itr]
        .sf_RunningAverage);

      /* End of InitializeConditions for SubSystem: '<S10>/camPoint 2 double' */
    }

    /* End of InitializeConditions for SubSystem: '<S10>/camPoint 2 double' */
    /* InitializeConditions for Iterator SubSystem: '<S10>/Running Average' */
    for (ForEach_itr_c = 0; ForEach_itr_c < 3; ForEach_itr_c++) {
      /* InitializeConditions for Iterator SubSystem: '<S10>/Running Average' */

      /* InitializeConditions for MATLAB Function: '<S63>/Running Average' */
      Controller_RunningAverage_Init(&Controller_DWork.CoreSubsys[ForEach_itr_c]
        .sf_RunningAverage);

      /* End of InitializeConditions for SubSystem: '<S10>/Running Average' */
    }

    /* End of InitializeConditions for SubSystem: '<S10>/Running Average' */
    /* InitializeConditions for MATLAB Function: '<S11>/Simple PP guiadnce' */
    Controller_DWork.index = 1.0;
  }
}

/* Model terminate function */
void Controller_terminate(void)
{
  /* (no terminate code required) */
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
