/*
 * File: Controller.h
 *
 * Code generated for Simulink model 'Controller'.
 *
 * Model version                  : 1.432
 * Simulink Coder version         : 8.3 (R2012b) 20-Jul-2012
 * TLC version                    : 8.3 (Jul 21 2012)
 * C/C++ source code generated on : Wed Jun 05 11:40:13 2013
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#ifndef RTW_HEADER_Controller_h_
#define RTW_HEADER_Controller_h_
#ifndef Controller_COMMON_INCLUDES_
# define Controller_COMMON_INCLUDES_
#include <float.h>
#include <math.h>
#include <stddef.h>
#include <string.h>
#include "rtwtypes.h"
#include "rtw_shared_utils.h"
#include "rtGetInf.h"
#include "rtGetNaN.h"
#include "rt_nonfinite.h"
#endif                                 /* Controller_COMMON_INCLUDES_ */

#include "Controller_types.h"

/* Child system includes */
#define Observer_MDLREF_HIDE_CHILD_
#include "Observer.h"

/* Macros for accessing real-time model data structure */
#ifndef rtmGetErrorStatus
# define rtmGetErrorStatus(rtm)        ((rtm)->errorStatus)
#endif

#ifndef rtmSetErrorStatus
# define rtmSetErrorStatus(rtm, val)   ((rtm)->errorStatus = (val))
#endif

#ifndef rtmGetErrorStatusPointer
# define rtmGetErrorStatusPointer(rtm) ((const char_T **)(&((rtm)->errorStatus)))
#endif

/* Block signals for system '<S25>/Generate z' */
typedef struct {
  real_T z[12];                        /* '<S25>/Generate z' */
} rtB_Generatez_Controller;

/* Block signals for system '<S34>/Task activator' */
typedef struct {
  real_T active;                       /* '<S34>/Task activator' */
} rtB_Taskactivator_Controller;

/* Block signals for system '<S63>/Running Average' */
typedef struct {
  real_T means[2];                     /* '<S63>/Running Average' */
} rtB_RunningAverage_Controller;

/* Block states (auto storage) for system '<S63>/Running Average' */
typedef struct {
  real_T k;                            /* '<S63>/Running Average' */
} rtDW_RunningAverage_Controller;

/* Block signals for system '<S23>/CoreSubsys' */
typedef struct {
  rtB_RunningAverage_Controller sf_RunningAverage;/* '<S63>/Running Average' */
} rtB_CoreSubsys_Controller;

/* Block states (auto storage) for system '<S23>/CoreSubsys' */
typedef struct {
  CameraInputPoint Delay1_DSTATE;      /* '<S63>/Delay1' */
  CameraInputPoint Delay_DSTATE[2];    /* '<S63>/Delay' */
  CameraInputPoint Delay2_DSTATE[3];   /* '<S63>/Delay2' */
  CameraInputPoint Delay3_DSTATE[4];   /* '<S63>/Delay3' */
  rtDW_RunningAverage_Controller sf_RunningAverage;/* '<S63>/Running Average' */
} rtDW_CoreSubsys_Controller;

/* Block signals for system '<S24>/CoreSubsys' */
typedef struct {
  rtB_RunningAverage_Controller sf_RunningAverage;/* '<S66>/Running Average' */
} rtB_CoreSubsys_Controller_k;

/* Block states (auto storage) for system '<S24>/CoreSubsys' */
typedef struct {
  CameraInputPoint Delay_DSTATE[2];    /* '<S66>/Delay' */
  CameraInputPoint Delay1_DSTATE;      /* '<S66>/Delay1' */
  CameraInputPoint Delay2_DSTATE[3];   /* '<S66>/Delay2' */
  CameraInputPoint Delay3_DSTATE[4];   /* '<S66>/Delay3' */
  rtDW_RunningAverage_Controller sf_RunningAverage;/* '<S66>/Running Average' */
} rtDW_CoreSubsys_Controller_a;

/* Block signals (auto storage) */
typedef struct {
  rtB_CoreSubsys_Controller_k CoreSubsys_p[4];/* '<S24>/CoreSubsys' */
  rtB_CoreSubsys_Controller CoreSubsys[3];/* '<S23>/CoreSubsys' */
  rtB_Taskactivator_Controller sf_Taskactivator_e;/* '<S38>/Task activator' */
  rtB_Taskactivator_Controller sf_Taskactivator;/* '<S34>/Task activator' */
  rtB_Generatez_Controller sf_Generatez_h;/* '<S26>/Generate z' */
  rtB_Generatez_Controller sf_Generatez;/* '<S25>/Generate z' */
} BlockIO_Controller;

/* Block states (auto storage) for system '<Root>' */
typedef struct {
  CameraInputPoint Delay1_DSTATE;      /* '<S57>/Delay1' */
  CameraInputPoint Delay_DSTATE[2];    /* '<S57>/Delay' */
  CameraInputPoint Delay2_DSTATE[3];   /* '<S57>/Delay2' */
  CameraInputPoint Delay3_DSTATE[4];   /* '<S57>/Delay3' */
  real_T index;                        /* '<S11>/Simple PP guiadnce' */
  real_T k;                            /* '<S57>/Running Average' */
  real_T lastBeforeComplete[2];        /* '<S57>/MATLAB Function' */
  int32_T UnitDelay_DSTATE[3];         /* '<Root>/Unit Delay' */
  boolean_T lastBeforeComplete_not_empty;/* '<S57>/MATLAB Function' */
  rtDW_CoreSubsys_Controller_a CoreSubsys_p[4];/* '<S24>/CoreSubsys' */
  rtDW_CoreSubsys_Controller CoreSubsys[3];/* '<S23>/CoreSubsys' */
} D_Work_Controller;

/* External inputs (root inport signals with auto storage) */
typedef struct {
  MagnetometerInput mag;               /* '<Root>/mag' */
  CamInput camera;                     /* '<Root>/camera' */
  CameraInputPoint obstacles[3];       /* '<Root>/obstacles' */
  int32_T agent_index;                 /* '<Root>/agent_index' */
  CameraInputPoint all_robots[4];      /* '<Root>/all_robots' */
  CameraInputPoint target;             /* '<Root>/target' */
  real32_T mission_v[2];               /* '<Root>/mission_v' */
} ExternalInputs_Controller;

/* External outputs (root outports fed by signals with auto storage) */
typedef struct {
  int32_T servo_out[3];                /* '<Root>/servo_out' */
  int16_T heading;                     /* '<Root>/heading' */
  real_T current_pos[2];               /* '<Root>/current_pos' */
  real_T formation_reached;            /* '<Root>/formation_reached' */
  real32_T common_v[2];                /* '<Root>/common_v' */
  boolean_T observer_valid;            /* '<Root>/observer_valid' */
} ExternalOutputs_Controller;

/* Real-time Model Data Structure */
struct tag_RTM_Controller {
  const char_T * volatile errorStatus;
};

/* Block signals (auto storage) */
extern BlockIO_Controller Controller_B;

/* Block states (auto storage) */
extern D_Work_Controller Controller_DWork;

/* External inputs (root inport signals with auto storage) */
#ifdef __cplusplus

extern "C" {

#endif

  extern ExternalInputs_Controller Controller_U;

#ifdef __cplusplus

}
#endif

/* External outputs (root outports fed by signals with auto storage) */
#ifdef __cplusplus

extern "C" {

#endif

  extern ExternalOutputs_Controller Controller_Y;

#ifdef __cplusplus

}
#endif

/*
 * Exported Global Parameters
 *
 * Note: Exported global parameters are tunable parameters with an exported
 * global storage class designation.  Code generation will declare the memory for
 * these parameters and exports their symbols.
 *
 */
extern RunConfig runConfig;            /* Variable: runConfig
                                        * Referenced by:
                                        *   '<S10>/Active Formation'
                                        *   '<S10>/Constant1'
                                        *   '<S10>/Formation Rotation'
                                        *   '<S10>/N Active Agents'
                                        *   '<S19>/If force obstacle deactivate'
                                        */
extern real_T Kp;                      /* Variable: Kp
                                        * Referenced by: '<S9>/Kp'
                                        */
extern real_T Kp_formation;            /* Variable: Kp_formation
                                        * Referenced by: '<S31>/Gain'
                                        */
extern real_T controllerMethod;        /* Variable: controllerMethod
                                        * Referenced by: '<S2>/Constant'
                                        */
extern int16_T Setpoint;               /* Variable: Setpoint
                                        * Referenced by: '<Root>/Heading setpoint'
                                        */

/*
 * Exported States
 *
 * Note: Exported states are block states with an exported global
 * storage class designation.  Code generation will declare the memory for these
 * states and exports their symbols.
 *
 */
extern real_T logEntry[10];            /* '<Root>/Log memory' */

/* External data declarations for dependent source files */
extern const MagnetometerInput Controller_rtZMagnetometerInput;/* MagnetometerInput ground */
extern const CameraInputPoint Controller_rtZCameraInputPoint;/* CameraInputPoint ground */
extern const CamInput Controller_rtZCamInput;/* CamInput ground */

#ifdef __cplusplus

extern "C" {

#endif

  /* Model entry point functions */
  extern void Controller_initialize(void);
  extern void Controller_step(void);
  extern void Controller_terminate(void);

#ifdef __cplusplus

}
#endif

/* Real-time Model object */
#ifdef __cplusplus

extern "C" {

#endif

  extern RT_MODEL_Controller *const Controller_M;

#ifdef __cplusplus

}
#endif

/* Exported data declaration */
extern real_T r;

/*-
 * The generated code includes comments that allow you to trace directly
 * back to the appropriate location in the model.  The basic format
 * is <system>/block_name, where system is the system number (uniquely
 * assigned by Simulink) and block_name is the name of the block.
 *
 * Use the MATLAB hilite_system command to trace the generated code back
 * to the model.  For example,
 *
 * hilite_system('<S3>')    - opens system 3
 * hilite_system('<S3>/Kp') - opens and selects block Kp which resides in S3
 *
 * Here is the system hierarchy for this model
 *
 * '<Root>' : 'Controller'
 * '<S1>'   : 'Controller/Control Allocation'
 * '<S2>'   : 'Controller/Controller'
 * '<S3>'   : 'Controller/Radians to Degrees'
 * '<S4>'   : 'Controller/Subsystem'
 * '<S5>'   : 'Controller/invert'
 * '<S6>'   : 'Controller/Control Allocation/MATLAB Function'
 * '<S7>'   : 'Controller/Control Allocation/Omega - Servo'
 * '<S8>'   : 'Controller/Control Allocation/saturate'
 * '<S9>'   : 'Controller/Controller/Angle Controller'
 * '<S10>'  : 'Controller/Controller/Formation speed controller'
 * '<S11>'  : 'Controller/Controller/Observer Demo Controller'
 * '<S12>'  : 'Controller/Controller/Speed Controller'
 * '<S13>'  : 'Controller/Controller/ned2body'
 * '<S14>'  : 'Controller/Controller/Angle Controller/Degrees to Radians'
 * '<S15>'  : 'Controller/Controller/Angle Controller/NOrmalize angle2'
 * '<S16>'  : 'Controller/Controller/Angle Controller/Radians to Degrees'
 * '<S17>'  : 'Controller/Controller/Formation speed controller/Calculate readings'
 * '<S18>'  : 'Controller/Controller/Formation speed controller/Concat'
 * '<S19>'  : 'Controller/Controller/Formation speed controller/Controller'
 * '<S20>'  : 'Controller/Controller/Formation speed controller/Formation Selection'
 * '<S21>'  : 'Controller/Controller/Formation speed controller/Incidence Matrix'
 * '<S22>'  : 'Controller/Controller/Formation speed controller/Leader Controller'
 * '<S23>'  : 'Controller/Controller/Formation speed controller/Running Average'
 * '<S24>'  : 'Controller/Controller/Formation speed controller/camPoint 2 double'
 * '<S25>'  : 'Controller/Controller/Formation speed controller/Calculate readings/Generate Z'
 * '<S26>'  : 'Controller/Controller/Formation speed controller/Calculate readings/Generate Z1'
 * '<S27>'  : 'Controller/Controller/Formation speed controller/Calculate readings/Generate Z/Generate z'
 * '<S28>'  : 'Controller/Controller/Formation speed controller/Calculate readings/Generate Z1/Generate z'
 * '<S29>'  : 'Controller/Controller/Formation speed controller/Controller/Collision Avoidance'
 * '<S30>'  : 'Controller/Controller/Formation speed controller/Controller/Obstacle Avoidance'
 * '<S31>'  : 'Controller/Controller/Formation speed controller/Controller/Reach Formation'
 * '<S32>'  : 'Controller/Controller/Formation speed controller/Controller/saturate1'
 * '<S33>'  : 'Controller/Controller/Formation speed controller/Controller/Collision Avoidance/Obstacle Avoidance'
 * '<S34>'  : 'Controller/Controller/Formation speed controller/Controller/Collision Avoidance/Task Activator'
 * '<S35>'  : 'Controller/Controller/Formation speed controller/Controller/Collision Avoidance/Task Activator/Task activator'
 * '<S36>'  : 'Controller/Controller/Formation speed controller/Controller/Obstacle Avoidance/Compare To Zero'
 * '<S37>'  : 'Controller/Controller/Formation speed controller/Controller/Obstacle Avoidance/Obstacle Avoidance'
 * '<S38>'  : 'Controller/Controller/Formation speed controller/Controller/Obstacle Avoidance/Task Activator'
 * '<S39>'  : 'Controller/Controller/Formation speed controller/Controller/Obstacle Avoidance/Task Activator/Task activator'
 * '<S40>'  : 'Controller/Controller/Formation speed controller/Controller/Reach Formation/Compare To Constant'
 * '<S41>'  : 'Controller/Controller/Formation speed controller/Controller/Reach Formation/Passitivity formation'
 * '<S42>'  : 'Controller/Controller/Formation speed controller/Controller/Reach Formation/norm'
 * '<S43>'  : 'Controller/Controller/Formation speed controller/Controller/Reach Formation/saturate2'
 * '<S44>'  : 'Controller/Controller/Formation speed controller/Formation Selection/Degrees to Radians'
 * '<S45>'  : 'Controller/Controller/Formation speed controller/Formation Selection/Desired Formation1'
 * '<S46>'  : 'Controller/Controller/Formation speed controller/Formation Selection/Desired Formation2'
 * '<S47>'  : 'Controller/Controller/Formation speed controller/Formation Selection/Desired Formation3'
 * '<S48>'  : 'Controller/Controller/Formation speed controller/Formation Selection/Desired Formation4'
 * '<S49>'  : 'Controller/Controller/Formation speed controller/Formation Selection/Desired Formation5'
 * '<S50>'  : 'Controller/Controller/Formation speed controller/Formation Selection/Desired Formation6'
 * '<S51>'  : 'Controller/Controller/Formation speed controller/Formation Selection/Desired Formation7'
 * '<S52>'  : 'Controller/Controller/Formation speed controller/Formation Selection/Desired Formation8'
 * '<S53>'  : 'Controller/Controller/Formation speed controller/Formation Selection/Desired Formation9'
 * '<S54>'  : 'Controller/Controller/Formation speed controller/Formation Selection/Rotate'
 * '<S55>'  : 'Controller/Controller/Formation speed controller/Leader Controller/From robot 1'
 * '<S56>'  : 'Controller/Controller/Formation speed controller/Leader Controller/Goto Target'
 * '<S57>'  : 'Controller/Controller/Formation speed controller/Leader Controller/Static point'
 * '<S58>'  : 'Controller/Controller/Formation speed controller/Leader Controller/zero out'
 * '<S59>'  : 'Controller/Controller/Formation speed controller/Leader Controller/Goto Target/Reach Target'
 * '<S60>'  : 'Controller/Controller/Formation speed controller/Leader Controller/Goto Target/Reach Target/Reach Target'
 * '<S61>'  : 'Controller/Controller/Formation speed controller/Leader Controller/Static point/MATLAB Function'
 * '<S62>'  : 'Controller/Controller/Formation speed controller/Leader Controller/Static point/Running Average'
 * '<S63>'  : 'Controller/Controller/Formation speed controller/Running Average/running average1'
 * '<S64>'  : 'Controller/Controller/Formation speed controller/Running Average/running average1/Running Average'
 * '<S65>'  : 'Controller/Controller/Formation speed controller/camPoint 2 double/camPoint -> double'
 * '<S66>'  : 'Controller/Controller/Formation speed controller/camPoint 2 double/running average1'
 * '<S67>'  : 'Controller/Controller/Formation speed controller/camPoint 2 double/camPoint -> double/Select point'
 * '<S68>'  : 'Controller/Controller/Formation speed controller/camPoint 2 double/running average1/Running Average'
 * '<S69>'  : 'Controller/Controller/Observer Demo Controller/Simple PP guiadnce'
 * '<S70>'  : 'Controller/Controller/Observer Demo Controller/waypoints'
 * '<S71>'  : 'Controller/Controller/Speed Controller/R^b_n'
 * '<S72>'  : 'Controller/Controller/Speed Controller/normalize max speed'
 * '<S73>'  : 'Controller/Controller/ned2body/R^b_n'
 * '<S74>'  : 'Controller/Controller/ned2body/normalize max speed'
 */
#endif                                 /* RTW_HEADER_Controller_h_ */

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
