function [ exportPath ] = exportPlot( figureNumber, fileName, size )
%EXPORTPLOT exporterer med den nye exportFig
    
    % First, check if figureNumber is a handle
    if any(ishandle(figureNumber))
        fig = figureNumber;
    else
        fig = figure(figureNumber);
    end

    % Get the full path
    exportPath = fullfile(getTexPath(), 'plots', fileName);
    
    % Default width
    fullsizeWidth = 12.1236;
    
    % Check for the size argument
    if nargin <= 2
        size = 'full';
    end
    
    if isnumeric(size)
        width = size*fullsizeWidth;
    else
    
        switch size
            case 'full'
                width = fullsizeWidth;
            case 'half'
                width = fullsizeWidth/2;
            case 'double'
                width = fullsizeWidth*2;
        end
    end
    
    exportfig(fig, exportPath, 'fontmode', 'fixed', ...
                                'fontsize', '8', ...
                                'width', width,...
                                'LineMode', 'fixed', 'LineWidth', 0.7);
    
    
end