/* 
 * Wrappers to make I/O functions available with C linkage. This allows C++
 * methods to be called from C code.
 *
 * Copyright 2009-2010 The MathWorks, Inc. */

#include <inttypes.h>
#include <stdio.h> /* for size_t */

#ifndef CPU_FREQ
#define CPU_FREQ 16000000L
#endif

//#ifndef TWI_FREQ
#define TWI_FREQ 1000L
//#endif



/* CUSTOM WIRE STUFF */
void wire_send(int val);
void wire_begin(int address);
void wire_end(void);
uint8_t wire_receive(void);
void wire_requestFrom(int address, int nBytes);
uint8_t wire_available(void);


/* Servo Library */
void servo_attach_c(int pin);
void servo_write_c(int pin, int value);



/* Serial Library */
void Serial_custom_begin(int port, long r);
void Serial_custom_read(int port, int showOutStatus, uint8_t *outData, int *outStatus);
void Serial_custom_write(int port, uint8_t * c, size_t s);