function makeInfo=rtwmakecfg()
%RTWMAKECFG adds include and source directories to the generated makefiles.
%   For details refer to documentation on the rtwmakecfg API.

% Copyright 1994-2011 The MathWorks, Inc.




arduino_path = arduino.Prefs.getArduinoPath;

% Core path. Serial library is also here.
arduino_inc_path = fullfile(arduino_path, 'hardware', 'arduino',...
                            'cores', 'arduino');
                        
% Add folder for wire and TWI library
arduino_wire_lib_path = fullfile(arduino_path, 'libraries', 'Wire', '');
arduino_twi_lib_path  = fullfile(arduino_path, 'libraries', 'Wire', 'utility', '');

% Add folder for Servo librayr
arduino_servo_lib_path = fullfile(arduino_path, 'libraries', 'Servo', '');

% Add folder for Serial library
arduino_serial_lib_path = fullfile(arduino_path, 'libraries', 'Servo', '');


% Add the folder where this file resides to the include path
blocks_inc_path = mfilename('fullpath');
blocks_inc_path = fileparts(blocks_inc_path)


% Set sources
makeInfo.sources = {'io_wrappers_i2c.cpp', ...
     fullfile(arduino_twi_lib_path, 'twi.c'), ...
     fullfile(arduino_wire_lib_path, 'Wire.cpp'), ...
     fullfile(arduino_servo_lib_path, 'Servo.cpp')
     };


makeInfo.includePath = {arduino_inc_path, blocks_inc_path, arduino_wire_lib_path, arduino_twi_lib_path, arduino_servo_lib_path};

