function [ handle ] = plot2d( input, format, plotFinal, timeRange)
%PLOT2D Summary of this function goes here
%   Detailed explanation goes here

    if nargin < 1
        error('Not enough input arguments');
    end
    

    if ~isa(input, 'timeseries')
        error('Input 1 must be of type timeseries');
    end
    
    if size(input.Data, 2) ~= 2
        error('Data input must be of size X * 2');
    end
    
    if nargin < 2
        format = '';
    end
    
    if nargin < 4
        timeRange = ones(1,length(input.Data(:,1)));
    end
    
    handle = plot(input.Data( timeRange,1), input.Data( timeRange,2), format);
    
    if nargin >= 3 && plotFinal == 1
       % Also plot final. 
 
       
       oldHandle = handle;
       handle = [];
       handle(1) = oldHandle;
       
       % remove linestasj from format
       format = strrep(format,'--', '');
       format = strrep(format,'-.', '');
       endIndex = find(timeRange, 1, 'last');
       handle(2) = plot(input.Data(endIndex,1), input.Data(endIndex,2), ['o' format]);
    end

end

