%% PLOTTING
hold on;

data = position.Data;
time = position.Time;

%figure(1); clf; hold on;
%figure(3); subplot(1,3,[2 3]); cla; hold on;
axis equal
colors = {'blue', 'red', 'green', 'magenta', 'cyan', 'yellow'};
legends = {};
legendIDs = [];
for i = 1:N
    
    xpos = reshape(data(1,i,:), [size(data, 3) 1]);
    ypos = reshape(data(2,i,:), [size(data, 3) 1]);
    
    plot(xpos, ypos, [colors{i} '--']);
    
    % Plot last position as a circle
    legendIDs(end+1) = plot(xpos(end), ypos(end), [colors{i} 'o']);
    legends{end+1} = sprintf('%g', i);
    
end
% Plot barycenter
baryX = 1/N*reshape(sum(data(1,:,:), 2), [size(data, 3) 1]);
baryY = 1/N*reshape(sum(data(2,:,:), 2), [size(data, 3) 1]);

dataLength = size(data, 3);
lookupVector = [1:ceil(dataLength/10):dataLength];

pId = plot(baryX(lookupVector), baryY(lookupVector), 'rx');





ylim([-1 1]);
xlim([-2 2]);
% Plot axis

line(xlim, [0 0], 'Color', 'k');
line([0 0], ylim, 'Color', 'k');
legend(legendIDs, legends)

%legend('1', '2', '3', 'barycenter', 'location', 'best');
% 
% % Plot velocities
% figure(2); clf
% 
% for i = 1:N
%     dimensionToPlot = 1;
%     
%     subplot(N,p, p*(i-1)+dimensionToPlot); 
%     
%     plot(time, reshape(data(dimensionToPlot,i,:), [size(data, 3) 1]))
%     
%     dimensionToPlot = 2;
%     
%     subplot(N,p, p*(i-1)+dimensionToPlot); 
%     
%     plot(time, reshape(data(dimensionToPlot,i,:), [size(data, 3) 1]))
%     
% end
