%% Common setup
addpath('../../libraries');
p = 2; % Planar

N = 4; % 3 robots


CTRLconfig.p = p;
CTRLconfig.N = N;

formation = [-0.5 -0.5; 0.5 -0.5;0.5 0.5;-0.5 0.5]';

%% Individual Control setup for each connection layout

Ds = {};
Names = {};

Names{end+1} = 'square';
Ds{end+1} = [-1  0  0  1;
              1 -1  0  0;
              0  1 -1  0;
              0  0  1 -1]; 

          
Names{end+1} = 'full';
Ds{end+1}= [-1  0  0  1 -1  0;
             1 -1  0  0  0  1;
             0  1 -1  0  1  0;
             0  0  1 -1  0 -1];
 
%% Run the simulations
D = Ds{1};

sim simpleFormation

% Plot results to figure 1 and 2
figure(1); clf
doPlot;
doPlotExtra;




% Run second simulation

D = Ds{2};
sim simpleFormation
         
% Plot results to figure 3 and 4
figure(2); clf;
doPlot;
doPlotExtra;      
         
         
         