/*
 * HardwareSerial.h
 *
 *  Created on: May 15, 2013
 *      Author: krisklau
 */

#ifndef HARDWARESERIAL_H_
#define HARDWARESERIAL_H_

#include "uart_channel.h" // For UARTChannelType
#include <stdint.h>
/*
 * This class will mimmick the behaviour of the Hardware Serial present on the Arduino.
 * For now, only support UART_2 !!!!!!!!
 *
 *
 *
 *
 */

// Support class for naming convention.
class Stream {
public:
	virtual bool available() = 0;
	virtual uint8_t read() = 0;
	virtual void write(uint8_t)  = 0;
	virtual void flush() = 0;

};


class HardwareSerial:public Stream {
public:
	HardwareSerial();
	int configure(UARTChannelType channel = UART_2);
	bool available();
	uint8_t read();
	void write(uint8_t);
	void flush();

	int open();
private:
	UARTChannelType channel;

	string port;

	bool is_configured;

	bool is_opened;

	int fd;

};

extern HardwareSerial Serial;

#endif /* HARDWARESERIAL_H_ */
