/*
 * UdpController.cpp
 *
 *  Created on: Apr 7, 2013
 *      Author: adamleon
 */

#include "StringController.h"

#include <errno.h>
#include <string.h>

#include <iostream>
using std::endl;
using std::cerr;
using std::cout;

StringClient::StringClient(string que_name, int buffer_size):dataPoint(DP_WRITE, que_name, buffer_size) {
	if(this->dataPoint.open() < 0) {
		cerr << "Error opening client. " << strerror(errno) << endl;
	}
}

int StringClient::send(string msg) {
	char buffer[this->dataPoint.get_msgSize()];
	for(int i = 0; i < this->dataPoint.get_msgSize(); i++) {
		if(i < msg.size()) {
			buffer[i] = msg[i];
		}
		else {
			buffer[i] = '\0';
		}
	}
	return this->dataPoint.send((void*) &buffer);
}

int StringClient::get_fd(void) {
	return this->get_fd();
}

int StringClient::numberOfMessages(void) {
	return this->dataPoint.numberOfMessages();
}

StringClient::~StringClient() {
	this->dataPoint.close();
}

StringHost::StringHost(string que_name, int buffer_size) :dataPoint(DP_READ, que_name, buffer_size) {
	if(this->dataPoint.open() < 0) {
		cerr << "Error opening host. " << strerror(errno) << endl;
	}
}

string StringHost::receive() {
	char buffer[this->dataPoint.get_msgSize()];
	if(this->dataPoint.recieve((void*) &buffer)< 0) {
		cerr << "Receive, out: " << strerror(errno) << endl;
	}
	string msg = buffer;
	return msg;
}

int StringHost::get_fd(void) {
	return this->dataPoint.get_fd();
}

int StringHost::numberOfMessages(void) {
	return this->dataPoint.numberOfMessages();
}

StringHost::~StringHost() {
	this->dataPoint.close();
}


