/*
 * UdpController.h
 *
 *  Created on: Apr 7, 2013
 *      Author: adamleon
 */

#ifndef STRINGCONTROLLER_H_
#define STRINGCONTROLLER_H_

#include <string>
#include <datapoint.h>

class StringClient {
public:
	StringClient(string que_name, int buffer_size);
	int send(string msg);
	int get_fd(void);
	int numberOfMessages(void);
	~StringClient();

private:
	DataPoint dataPoint;
};


class StringHost {
public:
	StringHost(string que_name, int buffer_size);

	string receive();
	int get_fd(void);
	int numberOfMessages(void);
	~StringHost();

private:
	DataPoint dataPoint;
};

class UdpClient : public StringClient {
public:
	UdpClient(int buffer_size = 1024) : StringClient("/udpController", buffer_size) {}
};

class UdpHost : public StringHost {
public:
	UdpHost(int buffer_size = 1024) : StringHost("/udpController", buffer_size) {}
};

class UdpCameraClient : public StringClient {
public:
	UdpCameraClient(int buffer_size = 1024) : StringClient("/udpCamera", buffer_size) {}
};

class UdpCameraHost : public StringHost {
public:
	UdpCameraHost(int buffer_size = 1024) : StringHost("/udpCamera", buffer_size) {}
};

class UdpMessageClient: public StringClient {
public:
	UdpMessageClient(int buffer_size = 1024) : StringClient("/udpMessage", buffer_size) {}
};

class UdpMessageHost : public StringHost {
public:
	UdpMessageHost(int buffer_size = 1024) : StringHost("/udpMessage", buffer_size) {}
};

#endif /* STRINGCONTROLLER_H_ */
