/*
 * analog_laser.h
 *
 *  Created on: Mar 5, 2013
 *      Author: adamleon
 */

#ifndef ANALOG_LASER_H_
#define ANALOG_LASER_H_

#include <iostream>
#include <errno.h>
#include <string>
#include <sys/fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#define TABLE_SIZE 10

using std::string;
using std::cout;
using std::endl;

enum AnalogPin {
	AIN0 = 1,
	AIN1 = 2,
	AIN2 = 3,
	AIN3 = 4,
	AIN4 = 5,
	AIN5 = 6,
	AIN6 = 7
};

class AnalogDevice {
private:
	string analogPath;
public:
	AnalogDevice(AnalogPin pin);
	int read();
};

class AnalogLaser : public AnalogDevice {
private:
	float lookupTable[TABLE_SIZE][2];
	float getFromTable(int measurement);
public:
	AnalogLaser(AnalogPin pin);

	float measureDistance();
};


#endif /* ANALOG_LASER_H_ */
