/*
 * beagle_led.cpp
 *
 *  Created on: Feb 7, 2013
 *      Author: krisklau
 */

#include "beagle_led.h"
#include <iostream>
#include <fcntl.h>
#include <stdio.h>


using std::cerr;
using std::endl;


// PAth to LED interface



static const char _LED_PATH_1[] = "/sys/class/leds/beaglebone::usr1/brightness";
static const char _LED_PATH_2[] = "/sys/class/leds/beaglebone::usr2/brightness";
static const char _LED_PATH_3[] = "/sys/class/leds/beaglebone::usr3/brightness";


BeagleLed::BeagleLed(BEAGLE_LED led) {
	switch(led) {
	case LED1:
		this->led = 1;
		this->path = _LED_PATH_1;
		break;
	case LED2:
		this->led = 2;
		this->path = _LED_PATH_2;
		break;
	case LED3:
		this->led = 3;
		this->path = _LED_PATH_3;
		break;
	default:
		this->led = 3;
		this->path = _LED_PATH_3;
		cerr << "Invalid LED chosen. Reverting to LED 3." << endl;
		break;
	}
}

void BeagleLed::on() {
	this->set(true);
}

void BeagleLed::off() {
	this->set(false);
}

void BeagleLed::set(bool value) {
	FILE *LEDHandle;
	if ((LEDHandle = fopen(this->path, "r+")) != NULL) {

		const char* valueString = (value) ? "1" : "0";

		fwrite(valueString, sizeof(char), 1, LEDHandle);
		fclose(LEDHandle);
	}

}

