/*
 * camera_host.cpp
 *
 *  Created on: Feb 25, 2013
 *      Author: krisklau
 */

#include "camera_client.h"


cam_msg_t getEmptyCamMsg(void) {
	cam_msg_t out;

	/* Set default out, if not present */
	out.pos.x = -10;
	out.pos.y = -10;

	out.aref.x = -10;
	out.aref.y = -10;

	out.valid = false;
	out.type = NONE;

	out.size = 0;

	return out;
}


int CameraClient::request(cam_msg_t* msg, int iRobotId) {
	cam_request_msg_t rq_msg;
	rq_msg.type = ROBOT;
	rq_msg.iId = iRobotId;

	//return request
	return request((void*) msg, (void*) &rq_msg);
}

int CameraClient::request(cam_msg_t* msg, CAMERA_POINT_TYPE type, int iId) {

	cam_request_msg_t rq_msg;
	rq_msg.type = type;
	rq_msg.iId = iId;

	//return request
	return request((void*) msg, (void*) &rq_msg);
}

int CameraClient::request(velocity_t* msg) {
	// Just a wrapper
	cam_msg_t actualMsg;

	cam_request_msg_t rq_msg;
	rq_msg.type = MISSION_V;
	rq_msg.iId = 1;

	int out = request((void*) &actualMsg, (void*) &rq_msg);

	if(actualMsg.type == MISSION_V) {
		msg->vel = actualMsg.pos;
	}
	return out;

}
