#ifndef GPIO_H_
#define GPIO_H_

#ifdef __cplusplus
extern "C" {
#endif

#define DIR_IN 1
#define TEXT_DIR_IN "in"
#define DIR_OUT 2
#define TEXT_DIR_OUT "out"

#define EDGE_NONE 1
#define TEXT_EDGE_NONE "none"
#define EDGE_RISING 2
#define TEXT_EDGE_RISING "rising"
#define EDGE_FALLING 3
#define TEXT_EDGE_FALLING "falling"
#define EDGE_BOTH 4
#define TEXT_EDGE_BOTH "both"

/*
 * GLOBAL FUNCTION PROTOTYPES
 */

/*
 *
 */
int write_mux_file(char *path, char *value, int len);

int gpio_export(int gpio);

/*
 *
 */
int gpio_set_direction(int gpio, int dir);

/*
 *
 */
int gpio_set_edge(int gpio, int edge);

/*
 *
 */
int gpio_open_read(int gpio);

/*
 *
 */
int gpio_open_write(int gpio);

/*
 *
 */
int gpio_read_int(int fd);

#ifdef __cplusplus
}
#endif


#endif /* GPIO_H_ */
