/*
 * logger.cpp
 *
 *  Created on: Feb 26, 2013
 *      Author: krisklau
 */

#include "logger.h"


// Use to get current time in file stamp
// and timestamp on log
#include <time.h>

#include <stdio.h> // for sprintf

#include <iomanip> // for precision setting
using std::fixed;
using std::setprecision;

#include <iostream>
using std::cerr;
using std::endl;

// debug
using std::cout;

// FUCK
#ifndef CLOCK_MONOTONIC
#define CLOCK_MONOTONIC 2
#error "Eclipse is stupid. This is just here to fix an indexing issue."
#endif




Logger::Logger(string log_name, bool addTimeStamp):first_run(true), add_timeStamp(addTimeStamp) {
	// The main job of the constructor are to genereate a unique filename,
	// based on the input string parameter and
	// current time.

	time_t rawtime;
	struct tm* timeinfo;
	char buffer[80];

	// Get current time
	time (&rawtime);
	timeinfo = localtime (&rawtime);

	// Convert to a usable string
	strftime(buffer, 80, "%F_%H-%M-%S", timeinfo);

	// Now insert fileending and log name.
	this->filename = string(LOG_PATH) + log_name + "-" + buffer + ".txt";



	/* Todo: Check if file already exists. */

}


void Logger::init() {
	// Simply creates and opens the file.
	this->file.open(this->filename.c_str(), ofstream::out);
	this->file.close();
}

// No longer needed..
void Logger::start() {
	/* Both start and end of write should perhaps empty the values vectors */



}

void Logger::add(const string& name, bool value) {
	double dValue = value?1:0;
	this->add(name, dValue);
}



void Logger::add(const string &name, double value) {
	// Only add names if first run
	if(this->first_run) {
		this->names.push_back(name);
	}

	// add value. If first run, it should always be added.
	// If not however, check that there is not more values than names.
	// If so, do not add but generate an error

	if(this->first_run || this->names.size() > this->values.size()) {
		this->values.push_back(value);
	}
	else {
		cout << "Invalid log entry. To many values." << endl;
	}

}

// Adds timestamp to the log
void Logger::timestamp() {
	// Only add names if first run
	if(this->first_run) {
		this->names.push_back("time");
		// Store time of first timestamp
		clock_gettime(CLOCK_MONOTONIC, &this->time_firstWrite);

	}

	if(this->first_run || this->names.size() > this->values.size()) {
		this->values.push_back(this->timeElapsed());
	}
	else {
		cout << "Invalid log entry. To many values." << endl;
	}

}

// Adds execution timestamp to the log
void Logger::execTimestamp() {
	// Only add names if first run
	if(this->first_run) {
		this->names.push_back("execTime");

	}

	if(this->first_run || this->names.size() > this->values.size()) {
		if(this->names[0] == "time") {
			this->values.push_back(this->timeElapsed() - this->values[0]);
		}
		else {
			this->values.push_back(this->timeElapsed());
		}
	}
	else {
		cout << "Invalid log entry. To many values." << endl;
	}

}



void Logger::addTable(double* array, int n, const string& prefix) {
	// If first run, push back some lognames
	if(this->first_run) {
		char buffer[10];
		for(int i = 0; i<n; i++) {
			snprintf(buffer, 10, "%d", i+1);
			this->names.push_back(prefix + string(buffer));
		}
	}

	// If first or enough room
	if(this->first_run || this->names.size() >= this->values.size()+n) {
		for(int i = 0; i<n; i++) {
			this->values.push_back(array[i]);
		}
	}
	else {
		cerr << "Invalid log entry. To many values." << endl;
	}

}

// Convert to double array and use the other method
void Logger::addTable(int* array, int n, const string& prefix) {
	double *table = new double[n];

	for(int i = 0; i<n;i++) {
		table[i] = static_cast<double>(array[i]);
	}

	addTable(table, n, prefix);

	delete(table);
}

// Convert to double array and use the other method
void Logger::addTable(float* array, int n, const string& prefix) {
	double *table = new double[n];

	for(int i = 0; i<n;i++) {
		table[i] = static_cast<double>(array[i]);
	}

	addTable(table, n, prefix);

	delete(table);
}


void Logger::write() {
	// Main writer!

	// Open file
	this->file.open(this->filename.c_str(), ofstream::out | ofstream::app);
	if(!this->file) {
		cerr << "error opening file." << endl;
	}

	// If first, add some nice columns to this shit.
	if(this->first_run) {

		cout << "First run done." << endl;


		// Insert all names
		for(vector<string>::iterator it = this->names.begin();
				it!= this->names.end(); ++it) {
			this->file << *it;

			if(it+1 != this->names.end()) {
				this->file << ",\t";
			}
		}
		this->file << endl;


		// No longer first run!
		this->first_run = false;

	}



	// Write all values
	for(vector<double>::iterator it = this->values.begin();
			it!= this->values.end(); ++it) {
		this->file << *it;

		if(it+1 != this->values.end()) {
			this->file << ",\t";
		}
	}
	this->file << endl;
	cout << endl;


	// Erase all values.
	this->values.erase(this->values.begin(), this->values.end());

	if(!this->file.good()) {
		cerr << "error writing to log file." << endl;
	}
	if(this->file.bad()) {
		cerr << "Error actually writing. Bad bit is set." << endl;
	}

	this->close();

}

void Logger::close() {
	this->file.close();
}


/* Subtract the `struct timeval' values X and Y,
   storing the result in RESULT.
   Return 1 if the difference is negative, otherwise 0. */

int timeval_subtract (struct timeval *result, struct timeval *x, struct timeval *y){
  /* Perform the carry for the later subtraction by updating y. */
  if (x->tv_usec < y->tv_usec) {
    int nsec = (y->tv_usec - x->tv_usec) / 1000000 + 1;
    y->tv_usec -= 1000000 * nsec;
    y->tv_sec += nsec;
  }
  if (x->tv_usec - y->tv_usec > 1000000) {
    int nsec = (x->tv_usec - y->tv_usec) / 1000000;
    y->tv_usec += 1000000 * nsec;
    y->tv_sec -= nsec;
  }

  /* Compute the time remaining to wait.
     tv_usec is certainly positive. */
  result->tv_sec = x->tv_sec - y->tv_sec;
  result->tv_usec = x->tv_usec - y->tv_usec;

  /* Return 1 if result is negative. */
  return x->tv_sec < y->tv_sec;
}


struct  timespec  _tsSubtract (
        struct  timespec & time1,
        struct  timespec & time2)
{    /* Local variables. */
    struct  timespec  result ;

/* Subtract the second time from the first. */

    if ((time1.tv_sec < time2.tv_sec) ||
        ((time1.tv_sec == time2.tv_sec) &&
         (time1.tv_nsec <= time2.tv_nsec))) {		/* TIME1 <= TIME2? */
        result.tv_sec = result.tv_nsec = 0 ;
    } else {						/* TIME1 > TIME2 */
        result.tv_sec = time1.tv_sec - time2.tv_sec ;
        if (time1.tv_nsec < time2.tv_nsec) {
            result.tv_nsec = time1.tv_nsec + 1000000000L - time2.tv_nsec ;
            result.tv_sec-- ;				/* Borrow a second. */
        } else {
            result.tv_nsec = time1.tv_nsec - time2.tv_nsec ;
        }
    }

    return (result) ;

}

double Logger::timeElapsed() {
	timespec time_now;
	clock_gettime(CLOCK_MONOTONIC, &time_now);
	timespec time_diff =  _tsSubtract(time_now, this->time_firstWrite);


	double diff = time_diff.tv_sec + time_diff.tv_nsec / double(1.0E9);

	return diff;

}







