/*
 * logger.h
 *
 *  Created on: Feb 26, 2013
 *      Author: krisklau
 */

#ifndef LOGGER_H_
#define LOGGER_H_



#ifdef __arm__
#define LOG_PATH "/home/root/Test/log/"
#else
#define LOG_PATH ""
#endif


#include <string>
#include <vector>
#include <iostream>
#include <fstream>


using std::ofstream;
using std::string;
using std::vector;

/*
 *
 */
class Logger {
public:
	Logger(string log_name = "log", bool addTimeStamp = true);
	void init();
	void start();
	void timestamp();
	void execTimestamp();
	void add(const string &name, double value);
	void add(const string &name, bool value);
	void addTable(float* array, int n, const string& prefix);
	void addTable(double* array, int n, const string& prefix);
	void addTable(int* array, int n, const string& prefix);
	void write();
	void close();
private:
	vector<string> names;
	vector<double> values;
	string filename;
	ofstream file;

	bool first_run;
	bool add_timeStamp;


	timespec time_firstWrite;
	double timeElapsed();

};

#endif /* LOGGER_H_ */
