/*
 * message_client.h
 *
 *  Created on: Apr 18, 2013
 *      Author: krisklau
 */

#ifndef MESSAGE_CLIENT_H_
#define MESSAGE_CLIENT_H_

#include <string>
using std::string;

// Uses the datapoint class
#include "datapoint.h"


#include "json/json.h"
using Json::Value;


#define MESSAGE_SIZE 1024

class message_request_t {
public:
	int request;
};



class MessageClient : public DataPointRequestClient {
public:
	MessageClient():DataPointRequestClient("/messageData", MESSAGE_SIZE, "/messageRequest", sizeof(message_request_t )) {};
	string request();
	Value requestJson();
	using DataPointRequestClient::set_timeout;

private:
	using DataPointRequestClient::request;
};

class MessageHost: public DataPointRequestHost {
public:
	MessageHost(): DataPointRequestHost("/messageData", MESSAGE_SIZE, "/messageRequest", sizeof(message_request_t )) {};
	int send_data(string &msg) { msg.resize(MESSAGE_SIZE); return DataPointRequestHost::send_data((void*) msg.c_str());};
	int read_request(message_request_t* rqMsg) { return DataPointRequestHost::read_request((void*) rqMsg);};
};


#endif /* MESSAGE_CLIENT_H_ */
