/*
 * particle.cpp
 *
 *  Created on: Mar 6, 2013
 *      Author: adamleon
 */

#include "particle.h"
#include <math.h>

/*
 * Coordinate class
 */
// Constructor
Coordinate::Coordinate(float x, float y) {
	this->x = x;
	this->y = y;
}

// Get and set x coordinate
void Coordinate::setX(float x) {
	this->x = x;
}

float Coordinate::getX() {
	return this->x;
}

// Get and set y coordinate
void Coordinate::setY(float y) {
	this->y = y;
}

float Coordinate::getY() {
	return y;
}


/**
 * Particle class
 */
// Constructor
Particle::Particle(float x, float y, float heading) {
	this->init_coord = Coordinate(x, y);
	this->heading = heading;
	this->reset();
}

// Reset the particle
void Particle::reset() {
	this->coord = Coordinate(this->init_coord.getX(), this->init_coord.getY());
	this->setWeight(0.5f);
}

// Get and set the current coordinates
void Particle::setCoordinates(float x, float y) {
	this->coord.setX(x);
	this->coord.setY(y);
}

Coordinate Particle::getCoordinates() {
	return this->coord;
}

// Get and set the weight
void Particle::setWeight(float weight) {
	if(weight > 1) {
		this->weight = 1;
	} else if(weight < 0) {
		this->weight = 0;
	} else {
		this->weight = weight;
	}
}

float Particle::getWeight() {
	return this->weight;
}

void Particle::setHeading(float heading) {
	this->heading = heading;
}

float Particle::getHeading() {
	return this->heading;
}

float Coordinate::getLength() {
	return sqrt((this->x * this->x) + (this->y * this->y));
}




