/*
 * particle.h
 *
 *  Created on: Mar 6, 2013
 *      Author: adamleon
 */

#ifndef PARTICLE_H_
#define PARTICLE_H_

// Two dimentional coordinates
class Coordinate {
private:
	// x and y coordinates
	float x, y;
public:
	// Constructor
	Coordinate(float x= 0, float y= 0);

	// Get and set x coordinate
	void setX(float);
	float getX();

	// Get and set y coordinate
	void setY(float);
	float getY();

	// Get the length of the coordinate
	float getLength();
};

// A particle in the particle filter
class Particle {
private:
	// The weight of the particle
	float weight;

	// The initial coordinates of the particle
	Coordinate init_coord;

	// The current coordinates of the particle
	Coordinate coord;

	float heading;
public:
	// Constructor
	Particle(float = 0, float = 0, float = 0.5);

	// Reset the particle
	void reset();

	// Get and set the current coordinates
	void setCoordinates(float, float);
	Coordinate getCoordinates();

	// Get and set the weight of the particle
	void setWeight(float);
	float getWeight();

	// Get and set the heading of the particle
	void setHeading(float);
	float getHeading();
};
#endif /* PARTICLE_H_ */
