/*
 * particle_controller.cpp
 *
 *  Created on: Mar 7, 2013
 *      Author: adamleon
 */

#include "particle_controller.h"

#define PARTICLE_QUEUE_NAME "/particleData"

#include <errno.h>
#include <string.h>

#include <iostream>
using std::endl;
using std::cerr;
using std::cout;

/**
 * Particle Client
 */
ParticleClient::ParticleClient():dataPoint(DP_WRITE, PARTICLE_QUEUE_NAME, sizeof(StateMessage)) {
	if(this->dataPoint.open() < 0) {
		cerr << "Error opening client. " << strerror(errno) << endl;
	}
}

int ParticleClient::send(StateMessage msg) {
	return this->dataPoint.send((void*) &msg);
}

int ParticleClient::get_fd() {
	return this->get_fd();
}

int ParticleClient::numberOfMessages() {
	return this->dataPoint.numberOfMessages();
}

ParticleClient::~ParticleClient() {
	this->dataPoint.close();
}

/*
 * Particle Host
 */
ParticleHost::ParticleHost():dataPoint(DP_READ, PARTICLE_QUEUE_NAME, sizeof(StateMessage)) {
	if(this->dataPoint.open() < 0) {
		cerr << "Error opening host. " << strerror(errno) << endl;
	}
}

StateMessage ParticleHost::receive() {
	StateMessage msg;
	if(this->dataPoint.recieve((void*) &msg)< 0) {
		cerr << "Receive, out: " << strerror(errno) << endl;
	}
	return msg;
}

int ParticleHost::get_fd(void) {
	return this->get_fd();
}

int ParticleHost::numberOfMessages(void) {
	return this->dataPoint.numberOfMessages();
}

ParticleHost::~ParticleHost() {
	this->dataPoint.close();
}


