#ifndef PWM_H_
#define PWM_H_

#ifdef __cplusplus
extern "C" {
#endif

// PWM0A (P9:31)
#define PWM0 1
#define PWM0A 11
#define PWM0A_MUX_FILE "/sys/kernel/debug/omap_mux/mcasp0_aclkx" // spi0_sclk
#define PWM0A_MUX_VALUE "1"
#define PWM0A_REQ "/sys/class/pwm/ehrpwm.0:0/request"
#define PWM0A_RUN "/sys/class/pwm/ehrpwm.0:0/run"
#define PWM0A_FREQ "/sys/class/pwm/ehrpwm.0:0/period_freq"
#define PWM0A_NS "/sys/class/pwm/ehrpwm.0:0/duty_ns"
#define PWM0A_PERCENT "/sys/class/pwm/ehrpwm.0:0/duty_percent"

// PWM0B (P9:29)
#define PWM0B 12
#define PWM0B_MUX_FILE "/sys/kernel/debug/omap_mux/mcasp0_fsx" // spi0_d0"
#define PWM0B_MUX_VALUE "1"
#define PWM0B_REQ "/sys/class/pwm/ehrpwm.0:1/request"
#define PWM0B_RUN "/sys/class/pwm/ehrpwm.0:1/run"
#define PWM0B_FREQ "/sys/class/pwm/ehrpwm.0:1/period_freq"
#define PWM0B_NS "/sys/class/pwm/ehrpwm.0:1/duty_ns"
#define PWM0B_PERCENT "/sys/class/pwm/ehrpwm.0:1/duty_percent"

// PWM1A (P9:14)
#define PWM1 2
#define PWM1A 21
#define PWM1A_MUX_FILE "/sys/kernel/debug/omap_mux/gpmc_a2"
#define PWM1A_MUX_VALUE "6"
#define PWM1A_REQ "/sys/class/pwm/ehrpwm.1:0/request"
#define PWM1A_RUN "/sys/class/pwm/ehrpwm.1:0/run"
#define PWM1A_FREQ "/sys/class/pwm/ehrpwm.1:0/period_freq"
#define PWM1A_NS "/sys/class/pwm/ehrpwm.1:0/duty_ns"
#define PWM1A_PERCENT "/sys/class/pwm/ehrpwm.1:0/duty_percent"

// PWM1B (P9:16)
#define PWM1B 22
#define PWM1B_MUX_FILE "/sys/kernel/debug/omap_mux/gpmc_a3"
#define PWM1B_MUX_VALUE "6"
#define PWM1B_REQ "/sys/class/pwm/ehrpwm.1:1/request"
#define PWM1B_RUN "/sys/class/pwm/ehrpwm.1:1/run"
#define PWM1B_FREQ "/sys/class/pwm/ehrpwm.1:1/period_freq"
#define PWM1B_NS "/sys/class/pwm/ehrpwm.1:1/duty_ns"
#define PWM1B_PERCENT "/sys/class/pwm/ehrpwm.1:1/duty_percent"

/*
 * initialize one PWM with a given frequency in Hz
 */
void pwm_init(int pwm, int frequency);

/*
 * set the value of a PWM channel as the duty cycle in nanoseconds
 */
int pwm_set_ns(int pwm_ch, long value);

/*
 * set the value of a PWM channel as the duty in percent
 */
int pwm_set_percent(int pwm_ch, int value);


/*
 * Stops the PWM module
 */
int pwm_stop(int pwm_ch);


/*
 * Starts the PWM module
 */
int pwm_start(int pwm_ch);

#ifdef __cplusplus
}
#endif



#endif /* PWM_H_ */
