/*
 * robot.cpp
 *
 *  Created on: Feb 14, 2013
 *      Author: krisklau
 */

#include "robot.h"
#include <iostream>
#include <stdlib.h> // For abs

using std::cerr;
using std::endl;



int Robot::init(void) {
	// Init all servos
	if(this->servoA.init() < 0) {
		cerr << "Robot: Error init servo A" << endl;
		return -1;
	}
	if(this->servoB.init() < 0) {
		cerr << "Robot: Error init servo B" << endl;
		return -1;
	}
	if(this->servoC.init() < 0) {
		cerr << "Robot: Error init servo C" << endl;
		return -1;
	}

	this->stop();
	return 0;

}

int Robot::setSpeed(int a, int b, int c) {
	if(abs(a) < 2) a = 0;
	if(abs(b) < 2) b = 0;
	if(abs(c) < 2) c = 0;

	this->servoA.write(90-a);
	this->servoB.write(90-b);
	this->servoC.write(90-c);

	return 0;
}

int Robot::setSpeed(double a, double b, double c) {
	if(abs(a) < 2) a = 0;
	if(abs(b) < 2) b = 0;
	if(abs(c) < 2) c = 0;

	this->servoA.write(90-a);
	this->servoB.write(90-b);
	this->servoC.write(90-c);

	return 0;
}



int Robot::set(ROBOT_MOTORS motor, int value) {
	switch(motor) {
	case RM_A:
		this->servoA.write(value);
		break;
	case RM_B:
		this->servoB.write(value);
		break;
	case RM_C:
		this->servoC.write(value);
		break;
	default:
		cerr << "Robot: Invalid motor selected" << endl;
		break;
	}
	return 0;
}

int Robot::set(ROBOT_MOTORS motor, float value) {
	switch(motor) {
	case RM_A:
		this->servoA.write(value);
		break;
	case RM_B:
		this->servoB.write(value);
		break;
	case RM_C:
		this->servoC.write(value);
		break;
	default:
		cerr << "Robot: Invalid motor selected" << endl;
		break;
	}

	return 0;
}

int Robot::stop() {
	return this->setSpeed(0,0,0);
}




