/*
 * servo_controller.cpp
 *
 *  Created on: Feb 8, 2013
 *      Author: krisklau
 */

#include "servo_controller.h"
#include "datapoint.h"

#include <errno.h>
#include <string.h>

#include <iostream>
using std::endl;
using std::cerr;
using std::cout;

#define QUE_NAME "/servoControl"



ServoClient::ServoClient():dataPoint(DP_WRITE, QUE_NAME, sizeof(ServoMessage)) {
	if(this->dataPoint.open() < 0) {
		cerr << "Error opening client. " << strerror(errno) << endl;
	}
}

int ServoClient::send(ServoMessage msg) {

	return this->dataPoint.send((void*) &msg);

}

int ServoClient::get_fd(void) {
	return this->get_fd();
}

int ServoClient::numberOfMessages(void) {
	return this->dataPoint.numberOfMessages();
}

ServoClient::~ServoClient() {
	this->dataPoint.close();
}

ServoHost::ServoHost() :dataPoint(DP_READ, QUE_NAME, sizeof(ServoMessage)) {
	if(this->dataPoint.open() < 0) {
		cerr << "Error opening host. " << strerror(errno) << endl;
	}
}

ServoMessage ServoHost::receive() {
	ServoMessage msg;
	if(this->dataPoint.recieve((void*) &msg)< 0) {
		cerr << "Receive, out: " << strerror(errno) << endl;
	}
	return msg;
}

int ServoHost::get_fd(void) {
	return this->dataPoint.get_fd();
}

int ServoHost::numberOfMessages(void) {
	return this->dataPoint.numberOfMessages();
}

ServoHost::~ServoHost() {
	this->dataPoint.close();
}

int RobotClient::send(int a, int b, int c) {
	ServoMessage msg;
	msg.a = a;
	msg.b = b;
	msg.c = c;

	return ServoClient::send(msg);

}

int RobotClient::send(int* table, int n) {
	if(n==3) {
		return send(table[0], table[1], table[2]);
	}
	else {
		cerr << "Invalid number of servos to send. Sending zeros." << endl;
		return send(0,0,0);
	}
}




