/*
 * servo_controller.h
 *
 *  Created on: Feb 8, 2013
 *      Author: krisklau
 */

#ifndef SERVO_CONTROLLER_H_
#define SERVO_CONTROLLER_H_

#include "datapoint.h"


typedef struct {
	int a;
	int b;
	int c;
} ServoMessage;

/*
 *
 */



class ServoClient {
public:
	ServoClient();
	int send(ServoMessage msg);
	int get_fd(void);
	int numberOfMessages(void);
	~ServoClient();

private:
	DataPoint dataPoint;
};

class RobotClient: public ServoClient {
public:
	RobotClient():ServoClient(){};
	using ServoClient::send;
	int send(int a, int b, int c);
	int send(int* table, int n);
};


class ServoHost {
public:
	ServoHost();

	ServoMessage receive();
	int get_fd(void);
	int numberOfMessages(void);
	~ServoHost();

private:
	DataPoint dataPoint;
};


#endif /* SERVO_CONTROLLER_H_ */
