/*
 * uart_channel.h
 *
 *  Created on: Feb 7, 2013
 *      Author: adamleon
 */

#ifndef UART_CHANNEL_H_
#define UART_CHANNEL_H_

#ifdef __arm__
#define DUMMY_MODE 0
#else
#define DUMMY_MODE 1
#endif

#include <iostream>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <termios.h>
#include <sys/fcntl.h>
#include <unistd.h>

using namespace std;

/*
 * The type of UART channel used
 */
enum UARTChannelType {
	// TX: Pin 24, RX: Pin 26
	UART_1 = 1,

	// TX: Pin 21, RX: Pin 22
	UART_2 = 2,

	// UART_3 is not avaiable for use

	// TX: Pin 13, RX: Pin 11
	UART_4 = 4,

	// TX: Pin 37, RX: Pin 38
	UART_5 = 5
};

/*
 * UART Channel without handshake
 */
class UARTChannel {
private:
	UARTChannelType channel;

	string port;

	bool is_configured;

	bool is_opened;

	int fd;


public:
	UARTChannel();
	virtual ~UARTChannel();

	int configure(UARTChannelType);

	int write(string);

	int read(string&);

	int open();

	int close();

	int get_fd() { return this->fd;};


};

#endif /* UART_CHANNEL_H_ */
