/*
 * xbee_broadcast.cpp
 *
 *  Created on: May 14, 2013
 *      Author: krisklau
 */

#include "xbee_broadcast.h"
#include <stdint.h>

#include <iostream>
#include <iomanip>

using namespace std;

#ifndef __uint32_t_defined
typedef unsigned int uint32_t;
#endif

char destination[] = {0x40, 0x93, 0xD6, 0x71};

Xbee::Xbee() {
	// TODO Auto-generated constructor stub
	uart.configure(UART_2);

	// Keep it open!
	uart.open();
}

void Xbee::sendTest() {
	char data[]= {0x7e, 0x00, 0x04, 0x08, 0x52, 0x4E, 0x4a, 0x0d};

	string out;

	for(int i = 0; i < 8; i++) {
		out.append(1, data[i]);
	}
	cout << "Write status: " << uart.write(out) << endl;
}


void Xbee::send(string msg) {
	cout << "Sending..." << endl;
	// Okay, lets start building or packet.
	string header; // Not including startByte and length

	header.append(1, XBEE_ZB_FRAME_TX); // Transmit packet
	header.append(1,this->counter); // Set id to zero, that is, get no ack back
	increment();
	//uint32_t address = destinations[0];
	//uint32_t addressMSB = 0x007D33A2;
	char addressMSB[] = {0x00, 0x7D, 0x33, 0xA2};

	header.append((char *) &addressMSB, 4);
	header.append(1, 0x00);

	for(int i = 0; i< 4; i++) {
		header.append(1, destination[i]);
	}

	uint16_t networkAddress = XBEE_ZB_NADDR_UNKNOWN;

	//header.append((char *) &networkAddress, 2);

	header.append(1, 0xFF);
	header.append(1, 0xFE);

	header.append(1, 0x00); // Broadcast radius
	header.append(1, 0x00); // options

	header.append(msg);		// payload

	// calculate checksum

	uint8_t sum = 0;
	for(int i = 0; i < header.length(); i++) {
		sum += header.at(i);
	}
	sum = 0xFF - sum;

	header.append(1, sum);

	// Do the fancy preheader
	uint16_t size = header.length();

	string preamble;
	preamble.append(1, 0x7E);
	preamble.append(1, 00);
	preamble.append(1, 0xFF & size);
	preamble.append(header);

	for(int i = 0; i < preamble.length(); i++) {
		cout << " " << hex << (int)preamble.at(i);
	}
	cout << endl;

	uart.write(preamble);



}

void Xbee::receive(string& msg) {

}
