/*
 * xbee_broadcaster.h
 *
 *  Created on: May 14, 2013
 *      Author: krisklau
 */


/*
 * This will be a simple xbee interface using our own uart interface.
 * It will provide zero error detection, and will broadcast everything
 * to every predefined known node.
 */



#ifndef XBEE_BROADCASTER_H_
#define XBEE_BROADCASTER_H_



#define XBEE_ZB_FRAME_TX 0x10
#define XBEE_ZB_FRAME_NOACK 0x00
#define XBEE_ZB_NADDR_UNKNOWN 0xFFFE





#include "uart_channel.h"
#include <string>
#include <stdint.h>

using std::string;




/*
 *
 */
class Xbee {
public:
	Xbee();
	void send(string msg);
	void sendTest();
	void receive(string &msg);
	int get_fd() { return this->uart.get_fd();};


public:
	UARTChannel uart;
private:
	void increment() {(counter > 254) ? counter = 0:counter++;};
	uint8_t counter;
};


#endif /* XBEE_BROADCASTER_H_ */
