/*
 * pointContainer.cpp
 *
 *  Created on: Mar 18, 2013
 *      Author: krisklau
 */

#include "pointContainer.h"

RobotContainer::RobotContainer() {
	this->clear();
}
void RobotContainer::clear() {
	// initialize the array
	for(int i = 0; i < 6; i++) {
		this->array[i] = getEmptyCamMsg();
	}
	this->count = 0;
}


// Number of elements that is actually robots
int RobotContainer::size() {
	return this->count;
}

int RobotContainer::update(int iRobotId, cam_msg_t robot) {

	if(!(iRobotId > 0 && iRobotId <= 6)) {
		return -1;
	}
	// update size?
	if(array[iRobotId-1].type <= 0) {
		++count;
	}

	this->array[iRobotId-1] = robot;
	return 0;
}

cam_msg_t RobotContainer::get(int iRobotId) {
	cam_msg_t out = getEmptyCamMsg();

	/* Set default out, if not present */

	if(iRobotId <= 6 && iRobotId > 0) {
		out = this->array[iRobotId-1];
		this->array[iRobotId-1].valid = false;
	}
	out.size = this->size();
	return out;
}

void ObstacleContainer::add(Json::Value& obstacles) {
	// Extract a cam_msg and add to vector



	if(obstacles.isArray()) {
		for(unsigned int i = 0; i < obstacles.size(); i++) {

			cam_msg_t data = getEmptyCamMsg();

			data.pos.x = obstacles[i].get("x", -10).asFloat();
			data.pos.y = obstacles[i].get("y", -10).asFloat();
			data.valid = true;
			data.type = OBSTACLE;

			this->array.push_back(data);
		}
	}



}

cam_msg_t ObstacleContainer::get(int obstacleId) {
	if(obstacleId < this->array.size()) {
		this->array[obstacleId].size = this->size();
		return this->array[obstacleId];
	}
	return getEmptyCamMsg();
}






