/*
 * pointContainer.h
 *
 *  Created on: Mar 18, 2013
 *      Author: krisklau
 */

#ifndef POINTCONTAINER_H_
#define POINTCONTAINER_H_

#include "camera_client.h"
#include <vector>
#include "json/json.h"

using std::vector;






/*
 * Simple container. Also sets flag internal to invalid when issued get.
 */
class ObstacleContainer {
public:
	void add(Json::Value &obstacle);
	void clear() {this->array.clear();};
	cam_msg_t get(int obstacleId);
	int size() {return this->array.size();};

private:
	vector<cam_msg_t> array;
};




class RobotContainer {
public:
	RobotContainer();

	int update(int iRobotId, cam_msg_t robot);
	cam_msg_t get(int iRobotId);
	int size();
	void clear();
private:
	cam_msg_t array[6];
	int count;
};


#endif /* POINTCONTAINER_H_ */
