/*
 * main.cpp
 *
 *  Created on: Feb 12, 2013
 *      Author: krisklau
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>

#include <arpa/inet.h>
#include <assert.h>
#include <errno.h>
#include <signal.h>
#include <string.h>
#include <sys/wait.h>
#include <netdb.h>
#include <unistd.h>
#include <pthread.h>


#include "StringController.h"
#include "json/json.h"

#define BUFFER_SIZE 1024
#define PORT 1337

using namespace std;

void error(char *msg)
{
    perror(msg);
    exit(0);
}

void* UDPServer(void* param) {
	int* sockfd = (int*)param;
	sockaddr_in serverAddr, clientAddr;
	char buffer[BUFFER_SIZE];
	Json::Reader reader;
	Json::Value msg;

	// Lol?
	UdpCameraClient camera = UdpCameraClient();
	UdpMessageClient message;

	memset((char*) (&serverAddr), 0, sizeof(serverAddr));
	serverAddr.sin_family = AF_INET;
	serverAddr.sin_port = htons(PORT);
	serverAddr.sin_addr.s_addr = INADDR_ANY;
	if (bind(*sockfd, (struct sockaddr*) (&serverAddr), sizeof(serverAddr))
			== -1)
		error("Bind error");

	socklen_t size = (socklen_t)(sizeof(clientAddr));

	printf("UDPServer active\n");
	while(1) {
		if (recvfrom(*sockfd, &buffer, BUFFER_SIZE, 0,
				(struct sockaddr *) &clientAddr, &size) == -1)
			error("recvfrom error");

		if(!reader.parse(buffer, msg)) {
			//error("parse error");
			continue;
		}
		string type = msg.get("type", "master").asString();

		if(type == "camera" || type == "position_update" || type == "common_v") {
			//cout << "Got a message: " << msg << endl;
			camera.send(string(buffer));
		}
		else if(type == "command") {
			//cout << "Got a message: " << msg << endl;
			message.send(string(buffer));
		}
		else {
			cout << "Got wierd packet: " << type << endl;
		}
	}

	close(*sockfd);
	return 0;
}

void* UDPClient(void* param) {
	int* sockfd = (int*)param;
	sockaddr_in serverAddr;
	char buffer[BUFFER_SIZE];
	UdpHost channel(BUFFER_SIZE);

	memset((char*) &serverAddr, 0,sizeof(serverAddr));
	serverAddr.sin_family = AF_INET;
	serverAddr.sin_port = htons(PORT);
	serverAddr.sin_addr.s_addr = htonl(INADDR_BROADCAST); //inet_addr("10.0.2.15");

	printf("UDPClient active\n");
	while(1) {
		string msg =  channel.receive();
		for(int i = 0; i < BUFFER_SIZE; i++) {
			buffer[i] = msg[i];
		}
		//cout << "Sending: " << buffer << endl;
		//cout << "OR: " << msg << endl;

		if(sendto(*sockfd, &buffer , BUFFER_SIZE, 0,
				(struct sockaddr *)&serverAddr, sizeof(serverAddr)) == -1)
			error("udp comm: sendto error");
	}

	return 0;
}

int main(int argc, char** argv) {
	int sockfd;

	UdpClient clientMessage(BUFFER_SIZE);
	UdpClient clientMessage2(BUFFER_SIZE);
	string msg("{\"type\" : \"master\", \"message\" : {\"foo\" : 3, \"bar\" : true}}");
	clientMessage.send(msg);
	clientMessage2.send(msg);

	if((sockfd=socket( AF_INET , SOCK_DGRAM, 0 )) == -1)
		error("Socket error");

	// Set broadcast permissions
	int broadcastEnable=1;
	int ret=setsockopt(sockfd, SOL_SOCKET, SO_BROADCAST, &broadcastEnable, sizeof(broadcastEnable));


	pthread_t client, server;

	if(pthread_create(&client, NULL, &UDPClient, (void*)&sockfd) == -1)
		error("client thread error");

	if(pthread_create(&server, NULL, &UDPServer, (void*)&sockfd) == -1)
		error("server thread error");

	pthread_join(client, NULL);
	pthread_join(server, NULL);

	printf("main thread exit\n");
	return 0;
}


