/*
 * main.cpp
 *
 *  Created on: Feb 12, 2013
 *      Author: krisklau
 */

#include <iostream>
#include <stdlib.h>
#include <string>
#include "xbee_broadcast.h"
#include <stdlib.h>

#include "HardwareSerial.h"
#include "WProgram.h"
#include "XBee.h"

#include "json/json.h"

using namespace Json;
using namespace std;


class Xbee_node {
public:
	Xbee_node(){};
	int send(string& msg);
	bool available();
	int read(string& msg);
private:
	XBee xbee;
	ZBTxStatusResponse txStatus;
	ZBRxResponse rxResponse;
};


int main(int argc, char**argv) {


	bool sender = false;
	if(argc > 1) {
		sender = true;
	}

	// create the XBee object
	//XBee xbee = XBee();
	Xbee_node xbee;
	Serial.configure(UART_2);
	uint8_t payload2[] = { 'l', 'o', 'e' , 'l', 'e'};//,'l', 'e' };

	Value json;
	json["ha"] = "01234567890123456789012345678900123456789012345678901234567890";

	FastWriter writer;

	string message = writer.write(json);

/*
	XBeeAddress64 addr64_other = XBeeAddress64(0x0013a200, 0x408A7A85);

	// SH + SL Address of receiving XBee
	XBeeAddress64 addr64 = XBeeAddress64(0x0013a200, 0x4093D671);
	ZBTxRequest zbTx = ZBTxRequest(addr64, payload, message.length()-1);
	ZBTxStatusResponse txStatus = ZBTxStatusResponse();

	ZBRxResponse rx = ZBRxResponse();
	ModemStatusResponse msr = ModemStatusResponse();
*/





	while(1) {
		if(sender) {
			cout << "Trying to send: " << message << endl;
			cout << "Size: " << message.length() << endl;
			xbee.send(message);

		} // end if sender
		else {
			string result;
			if(xbee.read(result) >= 0) {
				cout << "GOt true!: " << result << endl;
			}

		} // end if not sender

		sleep(1);
	}








}

inline int Xbee_node::send(string& message) {
	uint8_t* payload = (uint8_t*)malloc((message.length()-1)*sizeof(uint8_t));
	memcpy(payload, message.c_str(), message.length()-1);

	XBeeAddress64 addr64 = XBeeAddress64(0x0013a200, 0x408A7A85);
	ZBTxRequest zbTx = ZBTxRequest(addr64, payload, message.length()-1);

	// Initialize status object.. (Do not know if this is needed here..
	txStatus = ZBTxStatusResponse();

	xbee.send(zbTx);
	// after sending a tx request, we expect a status response
	// wait up to half second for the status response
	if (xbee.readPacket(200)) {
		// got a response!

		// should be a znet tx status
		if (xbee.getResponse().getApiId() == ZB_TX_STATUS_RESPONSE) {

			// Fill
			xbee.getResponse().getZBTxStatusResponse(txStatus);

			// get the delivery status, the fifth byte
			if (txStatus.getDeliveryStatus() == SUCCESS) {
				// success.  time to celebrate
				cout << "Hurray" << endl;
				return 0;
			} else {
				// the remote XBee did not receive our packet. is it powered on?
				cerr << "Remote did not receive.." << endl;
			}
		}
	} else if (xbee.getResponse().isError()) {
		//nss.print("Error reading packet.  Error code: ");
		//nss.println(xbee.getResponse().getErrorCode());
		cerr << "Error: " << hex << (int)xbee.getResponse().getErrorCode() << endl;
	} else {
		// local XBee did not provide a timely TX Status Response -- should not happen
		cerr << "Did not get a good response.." << endl;
	}

	return -1;


}

inline bool Xbee_node::available() {
	return false;
}

inline int Xbee_node::read(string& msg) {

	xbee.readPacket();

	if (xbee.getResponse().isAvailable()) {
		// got something
		if (xbee.getResponse().getApiId() == ZB_RX_RESPONSE) {
			// got a zb rx packet

			// now fill our zb rx class
			xbee.getResponse().getZBRxResponse(rxResponse);

			if (rxResponse.getOption() == ZB_PACKET_ACKNOWLEDGED) {
				// the sender got an ACK
				cout << "Got ok" << endl;
			} else {
				// we got it (obviously) but sender didn't get an ACK
				cerr << "We did not ack!?" << endl;
			}
			// set dataLed PWM to value of the first byte in the data
			//analogWrite(dataLed, rx.getData(0));
			string data = string((char*)rxResponse.getData(), rxResponse.getDataLength());
			cout << data << endl;
			msg = data;
			return 0;
		}
		else {
			cerr << "SOmething bad.." << endl;
		}
	} else if (xbee.getResponse().isError()) {
		 //nss.print("Error reading packet.  Error code: ");
		 //nss.println(xbee.getResponse().getErrorCode());

		cerr << "Error reading: " << hex << (int)xbee.getResponse().getErrorCode() << dec << endl;
	   }

	return -1;

}


