/*
 * robot.cpp
 *
 *  Created on: Feb 14, 2013
 *      Author: krisklau
 */

#include "robot.h"
#include <iostream>

using std::cerr;
using std::endl;



int Robot::init(void) {
	// Init all servos
	if(this->servoA.init() < 0) {
		cerr << "Robot: Error init servo A" << endl;
		return -1;
	}
	if(this->servoB.init() < 0) {
		cerr << "Robot: Error init servo B" << endl;
		return -1;
	}
	if(this->servoC.init() < 0) {
		cerr << "Robot: Error init servo C" << endl;
		return -1;
	}

	return 0;

}

int Robot::setSpeed(int a, int b, int c) {
	this->servoA.write(a+90);
	this->servoB.write(b+90);
	this->servoC.write(c+90);

	return 0;
}

int Robot::set(ROBOT_MOTORS motor, int value) {
	switch(motor) {
	case RM_A:
		this->servoA.write(value);
		break;
	case RM_B:
		this->servoB.write(value);
		break;
	case RM_C:
		this->servoC.write(value);
		break;
	default:
		cerr << "Robot: Invalid motor selected" << endl;
		break;
	}
	return 0;
}

int Robot::set(ROBOT_MOTORS motor, float value) {
	switch(motor) {
	case RM_A:
		this->servoA.write(value);
		break;
	case RM_B:
		this->servoB.write(value);
		break;
	case RM_C:
		this->servoC.write(value);
		break;
	default:
		cerr << "Robot: Invalid motor selected" << endl;
		break;
	}

	return 0;
}


