/*
 * commandParser.cpp
 *
 *  Created on: Apr 30, 2013
 *      Author: krisklau
 */

#include "commandParser.h"

#include "json/json.h"

using Json::Value;
using Json::Reader;

Reader reader;


// Simply switches available commands
COMMAND getCommand(Json::Value& jMsg) {
	string command = jMsg.get("command", "none").asString();

	// Do this first, so as few strings compare as needed are done.
	if(command.compare("none") == 0)
		return COMMAND_NONE;

	if(command.compare("start") == 0)
		return START;
	if(command.compare("stop") == 0)
		return STOP;
	if(command.compare("formation") == 0)
		return FORMATION;
	if(command.compare("kill") == 0)
			return KILL;

	if(command.compare("update") == 0)
			return UPDATE;

	return COMMAND_NONE;
}

Formation getFormation(Json::Value& jMsg) {
	string formation = jMsg.get("formation", "none").asString();

	if(formation.compare("none") == 0)
		return Single;

	if(formation.compare("single") == 0)
		return Single;

	if(formation.compare("square") == 0)
		return Square;

	if(formation.compare("line") == 0)
		return Line;

	if(formation.compare("triangle") == 0)
		return Triangle;

	if(formation.compare("twoline") == 0)
		return TwoLine;
	if(formation.compare("twomission") == 0)
		return TwoMission;

	if(formation.compare("rotatedsquare") == 0)
		return RotatedSquare;

	return Single;
}

bool getActivateMission(Json::Value& jMsg) {
	int activate = jMsg.get("activate_v", 0).asInt();
	if(activate == 1)
		return true;

	return false;
}



