/*
 * main.cpp
 *
 *  Created on: Feb 13, 2013
 *      Author: krisklau
 */


#include <iostream>

#include <sys/select.h>
#include <sys/time.h>

#include <stdlib.h>

#include "imudata.h"
#include "timer.h"

using namespace std;


int main(int argc, char** argv) {


	// Just spawn the two threads





	//pthread_join(p_host, NULL);

	cout << "Starting.." << endl;


	fd_set descriptorSet;
	struct timeval tv;
	//DataPointRequestHost host("/rqTest", sizeof(ServoMessage), "/rqTest_request");

	IMUDataHost host;
	host.open();


	// START THE ACTUAL LOOP
	int i = 1;

	// Create periodic loop
	periodic_info timerInfo;

	make_periodic(1E5, &timerInfo);


	// Set up data

	IMU_data_msg dataMsg;
	dataMsg.data = 2;

	while(1) {

		FD_ZERO(&descriptorSet); 				// Init

		FD_SET(host.get_request_fd(), &descriptorSet); // Set
		FD_SET(timerInfo.timer_fd, &descriptorSet);

		// Setup 2 seconds timeout
		tv.tv_sec = 2;
		tv.tv_usec = 0;

		int retval = select(100, &descriptorSet, NULL, NULL, &tv);

		if (retval == -1) {
			cerr << "Host got error in select. " << endl;
		}
		else if(retval) { // Positive, means we got a select statement
			if (FD_ISSET(host.get_request_fd(), &descriptorSet)) {
				DP_request_msg rqMsg;
				if(host.read_request(&rqMsg) < 0) {
					cerr << "Invalid request msg" << endl;
				}

				cout << "Got request: " << rqMsg.request << endl;


				// send data.
				host.send_data(&dataMsg);

			}
			else if(FD_ISSET(timerInfo.timer_fd, &descriptorSet)) {
				cout << "10 Hz timer. Read new data" << endl;
				dataMsg.data = i;

			}
			else {
				cerr << "Invalid select out return." << endl;
			}

		}
		else { // timeout
			cerr << "Servo Controller reached a timeout. Zeroing values." << endl;
		}

		i++;
	}


	return 0;

}

