/*
 * app_cameraClient.cpp
 *
 *  Created on: Feb 25, 2013
 *      Author: krisklau
 */




/* This stuff will read much from the pc
 * and then make it availible to a controller.
 */



#include <iostream>

#include <sys/select.h>
#include <sys/time.h>

#include <stdlib.h>

#include "camera_client.h"

#include "uart_channel.h"

#include <stdarg.h>


#include "StringController.h"
#include "message_client.h"
#include "json/json.h"

#include <string>


using namespace std;



int main(int argc, char** argv) {






	cout << "Starting.." << endl;


	fd_set descriptorSet;
	struct timeval tv;

	MessageHost host;
	host.open();





	// Set up communication to the udp module
	UdpMessageHost comm;
	Json::Reader reader;
	Json::Value jsonObject;



	// Set up data
	cam_msg_t dataMsg;

	// FOR NOW: Only store latest string message!
	string defaultMessage = "{ \"command\": \"none\"}";
	string storedDataMessage = defaultMessage;


	while(1) {

		FD_ZERO(&descriptorSet); 				// Init

		FD_SET(host.get_request_fd(), &descriptorSet); // Set
		FD_SET(comm.get_fd(), &descriptorSet);

		// Setup 2 seconds timeout
		tv.tv_sec = 2;
		tv.tv_usec = 0;

		int retval = select(1024, &descriptorSet, NULL, NULL, &tv);

		if (retval == -1) {
			cerr << "Host got error in select. " << endl;
		}
		else if(retval) { // Positive, means we got a select statement
			if (FD_ISSET(host.get_request_fd(), &descriptorSet)) {

				/*
				 * Got a request for data
				 */

				message_request_t rqMsg;
				if(host.read_request(&rqMsg) < 0) {
					cerr << "Invalid request msg" << endl;
				}
				//cout << "Got a request..." << endl;
				//cout << "Sending: " << storedDataMessage << endl;
				// Simply send the data
				host.send_data(storedDataMessage);


				// Set stored message to default
				storedDataMessage = defaultMessage;


			}
			else if(FD_ISSET(comm.get_fd(), &descriptorSet)) {
				// Got message form the udp server.
				// This message is a json packet.


				string message = comm.receive();
				// only store commands
				if(reader.parse(message, jsonObject)) {

					string type = jsonObject.get("type", "none").asString();
					if(type == "command") {
						storedDataMessage = message;
					}
				}

				//cout << "message client got message: " << storedDataMessage << endl;



			}
			else {
				cerr << "Invalid select out return." << endl;
			}

		}
		else { // timeout
			//cerr << "Message timeout." << endl;
		}

	}


	return 0;

}

