/*
 * main.cpp
 *
 *  Created on: Feb 12, 2013
 *      Author: krisklau
 */

#include <pthread.h>
#include <iostream>

#include <sys/select.h>
#include <sys/time.h>

#include <stdlib.h>

#include "servo_controller.h"
#include "robot.h"
#include "pwm.h"

using namespace std;


int main(int argc, char** argv) {

	/*
	pwm_init(PWM0, 48);
	while(1) {
		cout << "start " << endl;
		pwm_set_ns(PWM0B, 1E6*1.0);

		sleep(1);
		pwm_set_ns(PWM0B, 1E6*1.5);


		sleep(1);
		pwm_set_ns(PWM0B, 1E6*2);

		sleep(1);
		pwm_set_ns(PWM0B, 1E6*1.5);

		sleep(1);
	}
	*/

	fd_set descriptorSet;
	struct timeval tv;
	ServoHost servo;

	Robot robot;
	robot.init();
	robot.stop();

	// START THE ACTUAL LOOP

	while(1) {

		FD_ZERO(&descriptorSet); 				// Init

		FD_SET(servo.get_fd(), &descriptorSet); // Set

		// Setup 2 seconds timeout
		tv.tv_sec = 2;
		tv.tv_usec = 0;

		int retval = select(servo.get_fd()+1, &descriptorSet, NULL, NULL, &tv);

		if (retval == -1) {
			cerr << "Servo controller got error in select. " << endl;
		}
		else if(retval) { // Positive, means we got a select statement
			if (FD_ISSET(servo.get_fd(), &descriptorSet)) {
				ServoMessage msg = servo.receive();
#ifndef __arm__
				cout << "Got: " << msg.a << " - " << msg.b << " - " << msg.c << endl;
#else
				robot.setSpeed(msg.a, msg.b, msg.c);
#endif
			}
			else {
				cerr << "Invalid select out return." << endl;
			}

		}
		else { // timeout
#ifndef __arm__
			cerr << "Servo Controller reached a timeout. Zeroing values." << endl;
#else
			//cerr << "timeout." << endl;
			robot.stop();
#endif
		}


	}

	return 0;

}

