#include "ColorParameter.h"
#include "types.h"


// Colors
Scalar COLOR_BLUE    = Scalar(255,0,0);
Scalar COLOR_RED     = Scalar(0,0,255);
Scalar COLOR_GREEN   = Scalar(0,255,0);
Scalar COLOR_MAGENTA = Scalar(255,0,255);
Scalar COLOR_CYAN    = Scalar(255,255,0);
Scalar COLOR_YELLOW  = Scalar(0,255,255);

Scalar COLORS[6] = {COLOR_BLUE, COLOR_RED, COLOR_GREEN, COLOR_MAGENTA, COLOR_CYAN, COLOR_YELLOW};




ColorParameter::ColorParameter(void)
{
	this->color = BLUE;
	this->init();
}

ColorParameter::ColorParameter(COLOR_e color) {
	this->color = color;
	this->init();
}


void ColorParameter::init(void) {

		// COMMON:
	this->erosionSize = 2; // Shrink
	this->dilationSize = 3; // enlarge
	this->secondDilationSize = 0;

	this->saturationLimits = Scalar(80, 255);
	this->valueLimits      = Scalar(40, 255);

	this->dilateFirst = false;


	switch (this->color) {
	case BLUE:
		this->drawColor = COLOR_BLUE;
		this->hueLimits = Scalar(110, 120);
		this->hueLimits = Scalar(112, 120);
		this->saturationLimits = Scalar(70, 255);

		this->dilationSize = 3; // enlarge
		this->erosionSize = 4; // Shrink
		this->secondDilationSize = 4;

		this->dilateFirst = true;

		break;
	case RED:
		this->drawColor = COLOR_RED;
		this->hueLimits = Scalar(170,180);

		this->erosionSize += 1;
		this->dilationSize += 3;

		break;

	case YELLOW:
		this->drawColor = COLOR_YELLOW;
		this->hueLimits = Scalar(25, 45);
		this->hueLimits = Scalar(20, 40);
		this->saturationLimits = Scalar(90, 255);
		break;

	case CYAN:
		this->drawColor = COLOR_CYAN;
		this->hueLimits = Scalar(95, 108);
		this->hueLimits = Scalar(100, 112);
		

		break;
	case GREEN:
		this->drawColor = COLOR_GREEN;
		this->hueLimits = Scalar(60, 100);
		this->hueLimits = Scalar(45, 80);

		this->saturationLimits = Scalar(70, 255);

		this->dilationSize = 4;
		this->erosionSize = 2; // Shrink
		//this->dilateFirst = true;

		break;

	case MAGENTA:
		this->drawColor = COLOR_MAGENTA;
		this->hueLimits = Scalar(160, 170);

		this->erosionSize = 2;

		this->dilationSize = 5;
		this->erosionSize = 4; // Shrink
		

		break;

	}


}



Scalar ColorParameter::getLower(void) const {
	return Scalar(this->hueLimits[0], this->saturationLimits[0], this->valueLimits[0]);
}
Scalar ColorParameter::getUpper(void) const {
	return Scalar(this->hueLimits[1], this->saturationLimits[1], this->valueLimits[1]);
}