#pragma once


#include "types.h"


// Colors
extern Scalar COLOR_BLUE   ;
extern Scalar COLOR_RED    ;
extern Scalar COLOR_GREEN  ;
extern Scalar COLOR_MAGENTA;
extern Scalar COLOR_CYAN   ;
extern Scalar COLOR_YELLOW ;

extern Scalar COLORS[];




class ColorParameter
{
public:
	ColorParameter(void);
	ColorParameter(COLOR_e color);

	Scalar getLower(void) const;
	Scalar getUpper(void) const; 

	int getErosionSize(void) const {return this->erosionSize;};
	int getDilationSize(void) const {return this->dilationSize;};
	int getSecondDilationSize(void) const {return this->secondDilationSize;};

	Scalar getDrawColor(void) const { return this->drawColor;};

	bool doDilationFirst(void) const { return this->dilateFirst;};

	COLOR_e getColor(void) const {return this->color;};


private:
	void init(void);


	COLOR_e color;
	Scalar drawColor;

	Scalar hueLimits;
	Scalar saturationLimits;
	Scalar valueLimits;



	int erosionSize;
	int dilationSize;

	bool dilateFirst;
	int secondDilationSize;
};

