#ifdef _WIN32

#include "myCom.h"
#include <iostream>

using namespace std;

HANDLE comPort = NULL;
COMMTIMEOUTS comTimeouts;
DCB comSettings;

int com_configure(void) {
	if((comPort = CreateFile(SERIAL_PORT, 
						GENERIC_READ | GENERIC_WRITE,
						0,	// Excluseive access
						NULL, // Default security
						OPEN_EXISTING,
						FILE_FLAG_NO_BUFFERING,
						NULL)) == INVALID_HANDLE_VALUE) {

		cout << "Error opening com-port" << endl;
	}


	// Set timeout stuff
	comTimeouts.ReadIntervalTimeout         = 0; 
    comTimeouts.ReadTotalTimeoutMultiplier  = 0; 
    comTimeouts.ReadTotalTimeoutConstant    = 1;
    comTimeouts.WriteTotalTimeoutMultiplier = 0;
    comTimeouts.WriteTotalTimeoutConstant   = 000;
    int bStatus = SetCommTimeouts(comPort,&comTimeouts);

	if(bStatus < 0) {
		cerr << "lol timeout" << endl;
	}

	// Set parameters
	// Make a call to GetCommState() first in order to fill
    // the comSettings structure with all the necessary values.
    // Then change the ones you want and call SetCommState().
    GetCommState(comPort, &comSettings);
    comSettings.BaudRate = 57600;
    comSettings.StopBits = ONESTOPBIT;
    comSettings.ByteSize = 8;
    comSettings.Parity   = NOPARITY;
    comSettings.fParity  = FALSE;
    bStatus = SetCommState(comPort, &comSettings);
	if(bStatus < 0) {
		cerr << "lol" << endl;
	}
	/* error checking-- */

	return 0;
}
int com_write(string msg) {
	DWORD bytesWritten = 0;
	char eof = 0x04;
	//msg.append(eof, 1);
	msg += (char)0x04;
	if(WriteFile(comPort, &msg[0], msg.size(), &bytesWritten, NULL) == 0) { // Windows, returns zero on fail. Bah..
		cerr << "Error writing shit" << endl;
		return -1;
	}
	// Write end of file
	/*
	char eof = 0x04;
	DWORD tmp_bytes;
	if(WriteFile(comPort, &eof, 1,&tmp_bytes, NULL) < 0) {
		cerr << "Error writing eof" << endl;
		return -1;
	}
	*/
	return static_cast<int>(bytesWritten);
}


int com_read_nonblock(string &msg) {
	// Using the windows function ReadFile.
	// Since the timeout is asyncrhonous, this should work straight from the box

	char buffer[100];
	DWORD bytesRead = 0;

	if(ReadFile(comPort, buffer, (DWORD) 20, &bytesRead, NULL) == 0) {
		cerr << " No read! " << endl;

		return -1;
	}
	if(bytesRead > 0) {

		msg.assign(buffer, bytesRead);
		return 0;

	}
	else if(bytesRead == 0) {
		cout << "EOF!" << endl;
	}
	return -1;

}


#endif