#include "recorder.h"

#include <string>
#include <iostream>


#ifdef _WIN32

#include "kinect.h"

using std::string;
using std::cout;
using std::endl;
using std::wcout;

VideoWriter recorder_writer;
volatile bool _stopRecording;
DWORD WINAPI RecordThread(LPVOID lpParam);


bool startRecording() {
	if(!recorder_writer.isOpened()) {
		//writer.open("test.avi", -1, 10, rgbMat.size());
		CreateThread(NULL, 0, RecordThread, NULL, 0, NULL);
	}
	return true;
}

bool stopRecording() {
	_stopRecording = true;

	return true;
}
bool saveImage() {
	// Store image
	Mat src(Size(640,480),CV_8UC3,Scalar(0));
	device.getVideo(src);
	bool out = imwrite(getDateString() + ".jpg", src);
	cout << "Got: " << out << endl;

	return out;
}


// Thread to to some recording!
DWORD WINAPI RecordThread(LPVOID lpParam) {

	int framerate = 25;
	
	cout << "Started recording.." << endl;
	
	Mat rgbMat_recorder(Size(640,480),CV_8UC3,Scalar(0));

	//MyFreenectDevice device = *((MyFreenectDevice*) lpParam);

	string filename = getDateString() + ".avi";
	recorder_writer.open(filename, CV_FOURCC('D','I','V','X'), framerate, rgbMat_recorder.size());
	_stopRecording = false;

	/*
	/* Windows Timer stuff
	*/

	HANDLE hTimer = NULL;    // WaitableTimer handle
    hTimer = CreateWaitableTimer(    // Create waitable timer
        NULL,
        FALSE,    // Autoreset --> timer restarts counting after event fired
        NULL);

    SYSTEMTIME time;        // System time structure
    GetSystemTime(&time);    // Curren time
    //time.wSecond += 3;        // Wait 3 sec
	time.wMilliseconds += 1000/framerate;	// 25 fps

    FILETIME ftime;    // File time (expected by SetWaitableTimer)
    SystemTimeToFileTime(&time, &ftime);    // Convert system to file time


    if(!SetWaitableTimer(    // Set waitable timer
        hTimer,    // Timer handle
        reinterpret_cast<LARGE_INTEGER*>(&ftime),    // Convert file time to large integer
        1000/framerate,    // Period time, fire again after 2 sec
        NULL,
        NULL,
        0))
    {
            cout << "SetWaitableTimer failed" <<  GetLastError() << endl;
    };

    
    while(WaitForSingleObject(hTimer, 5000) == WAIT_OBJECT_0){    // Wait for timer event
        device.getVideo(rgbMat_recorder);
		if(recorder_writer.isOpened()) {
			recorder_writer.write(rgbMat_recorder);
		}
		if(_stopRecording) {
			break;
		}
    }
        
	recorder_writer.release();
    CancelWaitableTimer(hTimer);    // Stop timer
    CloseHandle(hTimer);            // Delete handle

	return 0;


	while(!_stopRecording) {

		 device.getVideo(rgbMat_recorder);
		if(recorder_writer.isOpened()) {
			recorder_writer.write(rgbMat_recorder);
		}

		int c_ = waitKey(1000/25 );
		
	}
	recorder_writer.release();
	cout << "Stopped! " << endl;
	
	return 0;

}


string getDateString() {
	LPWSTR buffer = new WCHAR[50];
	GetTimeFormatEx(NULL, 0, NULL, L"H_mm_ss", buffer, 50);

	LPWSTR buffer2 = new WCHAR[100];
	GetDateFormatEx(NULL, 0, NULL, NULL, buffer2, 100, NULL);

	LPWSTR buffer_complete = new WCHAR[150];
	swprintf(buffer_complete, L"%s_%s", buffer2, buffer);

	char ch[250];
	char DefChar= '_';
	WideCharToMultiByte(CP_ACP, 0, buffer_complete, -1, ch, 250, &DefChar, NULL);

	wcout << buffer_complete << endl;
	cout << ch << endl;

	string date = string(ch);

	string filename = "" + date + ".jpg";

	return date;
}


#else


string getDateString() {return "";};

bool startRecording(){ return true;};
bool stopRecording() {return true;};
bool saveImage() {return true;};


#endif