mfilename

% Find the file
D = dir('.');
D = D(find(~cellfun(@isempty,{D(:).date})));
theFile = D(3).name;
data = dataset('File', [theFile], 'Delimiter', ',');


logRootPath = './';
filename = 'log-2013-04-15_15-53-33 - NSB 1 target.txt';

[data, filename] = getBBLog(filename, [logRootPath]);  % gets the newest from Njord
parseLog;



figure(1); clf; hold on;





% THE VALUES FOR THIS TEST:
% d = 0.3;
% gain obs: 1
% gain goto: 0.5


% Plot the system for the NSB test

time = data.time;

obstacle = [data.obstacle_1_X data.obstacle_1_Y];
obstacle = obstacle(1,:);

pos      = [data.observed_pos1 data.observed_pos2];

goal     = [data.target_X(end) data.target_Y(end)];
    

d = 0.3;

plot(pos(:,1), pos(:,2), '--')
plot(obstacle(:,1), obstacle(:,2), 'ro')


%%
figure(1); clf


x = pos(:,1);
y = pos(:,2);

agent_path = plot(x, y, '--'); hold on;
legendAppend(agent_path, 'Vehicle path');


% Plot obstacles

    t = 0:0.01:2*pi;
    plot(d*cos(t)+obstacle(1), d*sin(t)+obstacle(2), 'r');
    plot(obstacle(1),obstacle(2), 'r*');
    text(obstacle(1),obstacle(2)-0.1, 'obstacle');


% Plot goal

plot(goal(1), goal(2),'+g')
plot(x(1), y(1), 'g*');
text(x(1), y(1)+0.05, 'start');
text(goal(1), goal(2)-0.05, 'target')

axis equal
ylim([0.3 0.9]);
xlim([0 1.5]);

title('NSB proof-of-concept Robots')
xlabel('x'); ylabel('y');

%% Plot where obstacle avoidance is active
lookupVector = find(data.mlog8 == 1);

% Index the lookup-vector
n = 10;
lookupVector = lookupVector(1:ceil(length(lookupVector)/n):length(lookupVector));
a = plot(x(lookupVector), y(lookupVector), 'b');
set(a, 'LineWidth', 3)

lId = legendAppend(a, 'Obstacle active');

set(lId, 'location', 'SouthEast');


%% Plot x and y in seperate plots

figure(4); clf; hold on;

for i = 1:2
    subplot(2,1,i); hold on; grid on;
   
    plot(log.get('obs_pos').Values.Time, log.get('obs_pos').Values.Data(:,i), 'b');
    plot(log.get('meas_pos').Values.Time, log.get('meas_pos').Values.Data(:,i), '*');
   
    
    thePos = log.get('meas_pos').Values.Data(:,i);
    theTime = log.get('meas_pos').Values.Time;
    invalid = thePos(log.get('pos_valid').Values.Data == 0);
    invalidTime = theTime(log.get('pos_valid').Values.Data == 0);
    
    plot(invalidTime, invalid, '*r');
    
    legend( 'Observed', 'Measured');
end


%% Export the figure
%export(1, 'robot_NSB_proof_of_concept');



exportPlot(1, 'robot_NSB_proof_of_concept');
