%% Startup
addpath('../../libraries');

nullSpaceDimension = [2 2];
velDimension = 2;

% Create obstacles

obstacles = [1.3 -0.3]';

goal = [3 0]';


%% Simulate

sim nsbTest;


%% Plot results

figure(1); clf

x = pos.signals.values(:,1);
y = pos.signals.values(:,2);

agent_path = plot(x, y, '--'); hold on;
legendAppend(agent_path, 'Vehicle path');


% Plot obstacles

for i = 1:size(obstacles,2)
    
    obstacle = obstacles(:,i);
    t = 0:.01:2*pi;
    d = 0.5;

    plot(d*cos(t)+obstacle(1), d*sin(t)+obstacle(2), 'r');
    plot(obstacle(1),obstacle(2), 'r*');
    text(obstacle(1),obstacle(2)-0.1, 'obstacle');
end

% Plot goal

plot(goal(1), goal(2),'+g')
plot(0, 0, 'g*');
text(0,-0.1, 'start');
text(goal(1), goal(2)-0.1, 'target')

axis equal
ylim([-1 0.4]);
xlim([-0.5 3.5]);

title('NSB proof-of-concept')
xlabel('x'); ylabel('y');

%% Plot where obstacle avoidance is active
lookupVector = find(active.Data == 1);

% Index the lookup-vector
n = 10;
lookupVector = lookupVector(1:ceil(length(lookupVector)/n):length(lookupVector));
a = plot(x(lookupVector), y(lookupVector), 'b');
set(a, 'LineWidth', 3);

lId = legendAppend(a, 'Obstacle active');

set(lId, 'location', 'SouthEast');
